-- an afk nodule farmer, with automatic nodule detection
-- and behavioural management. By Nyscersul. Cos I'm a Ninja. Oh Yeah!

--==--==--==--==--
-- Ideas;
-- Will need to record time taken to complete a full run through of sector, 
-- then use basic logic to assess whether on course, and next step.
-- Run by command - /afknodule L5 L6 for example, setting crit sector, and r+r.
-- Flies through, no turning, hits turbo. Resets list each run through, 
-- but will only shoot at each enemy once, prioritising by likelyhood of kills/hits.
-- currently using simple multi targetting binds.
-- Flies through, jumps to r+r, then does again, occasionally scanning, using the
-- timed first run to assess approximately 1/4 of the distance of each run,
-- as an interval to scan for nodules. Upon appearance of nodules, it will jump out,
-- then return and begin dbtcargo, until dbtcargo reports no more cargo,
-- then it jumps to r+r, does a 180, pulls forwards 5000m, drops everything unwanted,
-- then returns to the fray.
-- Advanced Ideas;
-- use timer of sector run through to assess when to fly slow/fast -- odometer? Use distance, not time?
-- when missiles are still flying at many targets should wait before turboing clear.
-- add its own firing sequence allowing for allocation of missiles fire directly,
-- including concentration on attackers if needed.
-- add player evasion
-- Automatic sector selections, allowing a) to evade players on their arrival, 
-- and b) to allow usage of all types of mission, not just crits.
-- add ability to assess the amount of incoming attacks and nearby enemies,
-- and adjusting speed appropriately.
-- may need to add functionality to infiniturbo to allow for direct turbo speed selection.
-- Add timer functionality to reduce likelyhood of taking out one bot, 
-- collecting one nodule, and repeating.
-- add its own collection routine, allowing it to ignore all bar the best drops.
-- add support for turret gunners - request fire from certain turrets.
-- turret gunners could be managed directly via remotepilots automatic command sequence.
-- should enable usage by other players with just the remotepilot functions.
-- may be worthwhile uploading a truncated version of the remotepilots admin management and basic response system.
--==--==--==--==--

local noduleaction="idle"
local noduleactive=false
local noduleactionstate="idle"
local cputimer=Timer()
local flythroughstate=""
local nodulescollected=true
local RandR=""
local skirmish=""
local RandR_id=0
local skirmish_id=0
local waitingforcompletion=false
local speedgrabberactive=false
local speedtimer=Timer()
local speeds={}
local distancetravelled=0
local distancetimer=Timer()
local distancetrackeractive=false
local scanready=true
local nodulesfound=false
local sectorlength=0
local missilesactive=false
----==== Targetless checks
local hastargetless = false
local function targetless_exists()
	return pcall(function() return targetless end)
end
local function targetless_off()
	if hastargetless then
		targetless.var.scanlock = true
		targetless.api.radarlock = true
		targetless.var.lock = true
		return true
	end
	return false
end
local function targetless_on()
	if hastargetless then
		targetless.api.radarlock = false
		targetless.var.lock = false
		targetless.var.scanlock = false
		return true
	end
	return false
end
-- "local function foo()" is equivalent to "local foo; foo = function()",
-- so we can reference the function name in the function body properly.
local function targetless_check()
	UnregisterEvent(targetless_check, "START")
	UnregisterEvent(targetless_check, "PLAYER_ENTERED_GAME")
	hastargetless = targetless_exists()
end
hastargetless = targetless_exists()
if not hastargetless then
	RegisterEvent(targetless_check, "START")
	RegisterEvent(targetless_check, "PLAYER_ENTERED_GAME")
end
----==== Targetless check end  --targetless_off() and targetless_on()

-- GetNearestObjectDistance returns -1 if no objects are around
-- makes it return 3000 for clear signal, as per hud.
local function jumpclearance()
	if radar.GetNearestObjectDistance() >= 0 then
		return radar.GetNearestObjectDistance()
	elseif radar.GetNearestObjectDistance() == -1 then
		local clear = 3000
		return clear
	end
end


local function missilesbindtoggle()
	if missilesactive==false then
		gkinterface.GKProcessCommand("hostilityenemy")
		gkinterface.GKProcessCommand("dbmtmultiall")
		gkinterface.GKProcessCommand("dbmtfire")
		missilesactive=true
	elseif missilesactive==true then
		gkinterface.GKProcessCommand("dbmtholdfire")
		missilesactive=false
	end
end


function scanfornodules() -- simple radar scan, non-repeating. For calls frequently while flying. Expect minor lockups.
	local temptable={}
	if scanready==true then
		--begin scan
		targetless_off() -- Targetless off
		gkinterface.GKProcessCommand("RadarNone")
		local counter = 0
		local scanning = true
		while scanning == true do
			gkinterface.GKProcessCommand("RadarNext")  -- radar scan
			if GetTargetInfo() then
				local name=GetTargetInfo()
				if string.find(name,"Nodule") then
					counter=counter+1
					temptable[counter]=name
				end
			else
				scanning=false
			end
		end
		local check=true
		local counter2=0
		while check ~= false do
			local entry = temptable[counter2]
			if entry == nil and counter2~=0 then
				check=false
			end
			counter2=counter2+1
		end
		if counter2>1 then
			nodulesfound=true
		end
	end
end

function nodulecpucore(_,args)
	print(noduleaction)
	if noduleaction=="idle" then
		--begin, include action to check for appropriate arguments. Maybe bug out if none supplied.
		--arg1 = target skirm
		--arg2 = r+r
		if args[1]~=nil and args[2]~=nil then
			noduleactive=true
			RandR=args[2]
			skirmish=args[1]
			local system_name =SystemNames[GetCurrentSystemid()]
			RandR_id = SectorIDFromLocationStr(system_name..' '..RandR)
			skirmish_id = SectorIDFromLocationStr(system_name..' '..skirmish)
			noduleaction="firstmove"
			print("Arguments Received")
		elseif args[1]==nil or args[2]==nil then
			--report failure to ascertain intended locations
			print("Failed to ascertain destinations.")
		end
	elseif noduleaction=="firstmove" then
		local sector=GetCurrentSectorid()
		if RandR_id~=sector and waitingforcompletion==false then
			gkinterface.GKProcessCommand("dbplod "..RandR)
			gkinterface.GKProcessCommand("dbdelay nodulestepcomplete")
			waitingforcompletion=true
		elseif RandR_id~=sector and waitingforcompletion==true then
			--do nothing
		elseif RandR_id==sector and waitingforcompletion==true then
			noduleaction="measuresector"
			gkinterface.GKProcessCommand("dbplod "..skirmish)
		end
		-- move to (arg1) sector
	elseif noduleaction=="measuresector" then
		-- initiate jump to new sector, begin sector measurement.
		-- end by jumping back to (arg2) sector
		local sector=GetCurrentSectorid()
		local jumpclear=jumpclearance()
		if sector==skirmish_id and speedgrabberactive==false and distancetrackeractive==false then
			sectorlength=0
			distancetravelled=0
			distancetrackeractive=true
			speedgrabberactive=true
			speedgrabber()
			distancetracker()
			gkinterface.GKProcessCommand("dbtspeed")
			gkinterface.GKProcessCommand("it on")
			gkinterface.GKProcessCommand("it speed")
		elseif sector==skirmish_id and jumpclear > 2999 and speedgrabberactive==true and distancetrackeractive==true then
			local tempstring=("navroute add \""..LocationStr(RandR_id).."\"")
			gkinterface.GKProcessCommand(tempstring)
			sectorlength=distancetravelled
			local function delayed()
				gkinterface.GKProcessCommand("activate")
			end
			local delay=Timer()
			delay:SetTimeout(500,delayed)
		elseif sector==RandR_id and speedgrabberactive==true and distancetrackeractive==true then
			noduleaction="jumptoskirm"
		end
		-- check for jump readyness.
	elseif noduleaction=="jumptoskirm" then
		local sector=GetCurrentSectorid()
		local jumpclear=jumpclearance()
		if sector==RandR_id and dullbotisrunning==false and waitingforcompletion==false then
			waitingforcompletion=true
			gkinterface.GKProcessCommand("dbplod "..skirmish)
			gkinterface.GKProcessCommand("dbdelay nodulestepcomplete")
		elseif sector==RandR_id and waitingforcompletion==true then
			--skip
		elseif sector==skirmish_id and waitingforcompletion==false then
			noduleaction="flythrough"
		end
		-- begin actual sequence
		-- ends on entry to skirm sector.
	elseif noduleaction=="flythrough" then
		if flythroughstate=="" then
			gkinterface.GKProcessCommand("it on")
			missilesbindtoggle()
			distancetravelled=0
			speeds={}
			flythroughstate="underonequarter"
			scanfornodules()
		end
		if flythroughstate=="underonequarter" then
			if distancetravelled < (sectorlength/100) then
				scanfornodules()
			end
			if distancetravelled > (sectorlength/4) then
				flythroughstate="underhalfway"
				scanfornodules()
			end
		elseif flythroughstate=="underhalfway" then
			if distancetravelled > (sectorlength/2) then
				flythroughstate="underthreequarters"
				scanfornodules()
			end
		elseif flythroughstate=="underthreequarters" then
			if distancetravelled > ((sectorlength/4)*3) then
				flythroughstate="lastquarter"
				scanfornodules()
			end
		elseif flythroughstate=="lastquarter" then
			if distancetravelled > sectorlength then
				flythroughstate="done"
				scanfornodules()
			end
		elseif flythroughstate=="done" then
			flythroughstate=""
			noduleaction="jumpout"
			missilesbindtoggle()
		end
		-- upon entering, begin tracking distance. record to continually updated distance variable.
		-- at entry, at 1/4 pre recorded distance, at 1/2 and 3/4 and before jump out, scan for noodles.
	elseif noduleaction=="jumpout" then
		-- set navs, return to r+r
		local jumpclear=jumpclearance()
		if jumpclear>2999 then
			local tempstring=("navroute add \""..LocationStr(RandR_id).."\"")
			gkinterface.GKProcessCommand(tempstring)
			local function delayed()
				gkinterface.GKProcessCommand("activate")
			end
			local delay=Timer()
			delay:SetTimeout(500,delayed)
			noduleaction="restart"
		end
	elseif noduleaction=="restart" then
		-- check for nodules spotted, reset variables etc.
		if nodulesfound==true then
			noduleaction="nodulespotted"
		elseif nodulesfound==false then
			flythroughstate=""
		end
	elseif noduleaction=="nodulespotted" then
		nodulescollected=false
		missilesactive=true
		missilesbindtoggle()
		local jumpclear=jumpclearance()
		local sector=GetCurrentSectorid()
		gkinterface.GKProcessCommand("RadarNone")
		gkinterface.GKProcessCommand("RadarNext")
		local targetinfo=GetTargetInfo()
		if jumpclear>2999 and sector==RandR_id then
			local tempstring=("navroute add \""..LocationStr(RandR_id).."\"")
			gkinterface.GKProcessCommand(tempstring)
			local function delayed()
				gkinterface.GKProcessCommand("activate")
			end
			local delay=Timer()
			delay:SetTimeout(500,delayed)
		elseif jumpclear < 3000 and sector==RandR_id then
			--wait
		elseif sector==skirmish and targetinfo~=nil and waitingforcompletion==false then
			gkinterface.GKProcessCommand("dbtcargo")
			gkinterface.GKProcessCommand("dbdelay nodulestepcomplete")
			waitingforcompletion=true
		end
		-- begin cargo collection. Use distances nodules were spotted at to determine positions.
		-- currently uses dumbfire dbtcargo.
	end
	if noduleactive==true then
		cputimer:SetTimeout(2000,nodulecpucore)
	elseif noduleactive==false then
		cputimer:Kill()
		noduleaction="idle"
	end
end
function speedgrabber()
	if speedgrabberactive==true then
		local speed=GetActiveShipSpeed()
		if speed > -1 then
			table.insert(speeds,speed)
		end
		speedtimer:SetTimeout(100,speedgrabber)
	elseif speedgrabberactive==false then
		return
	end
end
function distancetracker()
	local counter=1
	local total=0
	local distance=0
	while counter>-1 do
		if speeds[counter]~=nil then
			local speed=math.floor(speeds[counter])
			if speed ~= nil then
				total=total+1
				distance=distance+speed
				counter=counter+1
			end
		elseif speeds[counter]==nil then
			counter=-1
		end
	end
	distancetravelled=(total*distance)/10
	if distancetrackeractive==true then
		distancetimer:SetTimeout(500,distancetracker)
	end
end
function dbdelaynotify()
	waitingforcompletion=false
end

RegisterUserCommand("nodulestepcomplete",dbdelaynotify)
RegisterUserCommand("nodulefarmer",nodulecpucore)