-- Dullbot Cargo Collector
-- An autonomous cargo collector front end for dullbot.
-- Is reliant on TargetTools for target selection, and dullbot for the actual
-- Movement.

-- Dullbot has added commands - approachcargo specifically 
-- which enable this functionality.




-- Timers - used throughout.
local dbcctimer=Timer()
local dbcctimer2=Timer()
local dbcctimer3=Timer()
local dbcctimer4=Timer()
local dbcctimer5=Timer()
local dbcctimer6=Timer()
local sendplayermessagestimer=Timer()
-- Functions
local getnodeid={}
local checkforore={}
local targetselectionroutine={}
local dullbotcargocollector={}
local sendplayermessages={}
local dullbotcargocycle={}

-- Variables by type
-- Booleans
dullbotcargocollectortoggle=false
declare("dullbotcargocollectortoggle",dullbotcargocollectortoggle)
local prioritiesconsidered=false
local targetfound=false
local orecheckboolean=false
local combatmode=false
local targetcycling=false
local firsttargetcycle=true
-- Integers/Counters
local targetcargotaps=0
local sendplayermessagecounter=0
local targettingtempcounter=0
-- TargetInfo!
local selecttargetinfo=GetTargetInfo()
-- String Variables
local specificcargo=""
-- Function : dullbotcargocollector
-- Sets main conditionals for beginning of cargo collection, including
-- reporting back to a remotely operating player when the remote pilot is active.
-- calls dullbotcargocycle, sendplayermessages
-- takes arguments "prioritise" and "combat", or nil.
-- prioritise selects targets via criteria and combat is an incomplete combat collector intended
-- to fire missiles whilst collecting. Combat mode would be able to be used with or without prioritisation.
-- nil args means all prioritisation ignored, simple closest target first.
-- closest first mode is an infinite mode - will need to be stopped manually.
-- prioritise stops itself when no drops of value.
local hastargetless = false
local function targetless_exists()
	return pcall(function() return targetless end)
end

local function targetless_off()
	if hastargetless then
		targetless.var.scanlock = true
		targetless.api.radarlock = true
		targetless.var.lock = true
		return true
	end
	return false
end
local function targetless_on()
	if hastargetless then
		targetless.api.radarlock = false
		targetless.var.lock = false
		targetless.var.scanlock = false
		return true
	end
	return false
end

-- "local function foo()" is equivalent to "local foo; foo = function()",
-- so we can reference the function name in the function body properly.
local function targetless_check()
	UnregisterEvent(targetless_check, "START")
	UnregisterEvent(targetless_check, "PLAYER_ENTERED_GAME")
	hastargetless = targetless_exists()
end

hastargetless = targetless_exists()
if not hastargetless then
	RegisterEvent(targetless_check, "START")
	RegisterEvent(targetless_check, "PLAYER_ENTERED_GAME")
end
function dullbotcargocollector(_,args)
	gkinterface.GKProcessCommand('targetnone')
	remoteresponsedullbotsuppression=true
	declare("remoteresponsedullbotsuppression",remoteresponsedullbotsuppression)
	if dullbotcargocollectortoggle==true then
		dullbotcargocollectortoggle=false
		declare("dullbotcargocollectortoggle",dullbotcargocollectortoggle)
		dbcctimer:Kill()
		dbcctimer2:Kill()
		dbcctimer3:Kill()
		combatmode=false
		specificcargo=""
		local tempstring = "Cargo Collection Deactivated"
		ProcessEvent("MESSAGE_WAITING",tempstring)
		remoteresponsedullbotsuppression=false
		declare("remoteresponsedullbotsuppression",remoteresponsedullbotsuppression)
	else
		dullbotcargocollectortoggle=true
		declare("dullbotcargocollectortoggle",dullbotcargocollectortoggle)
		if args then
			for i,v in pairs(args) do
				if v=="prioritise" then
					prioritiesconsidered=true
					local tempstring = "Prioritising drops. Ignoring Scrap Metal and Ores at range. Drop under 2000m away for guaranteed collection."
					ProcessEvent("MESSAGE_WAITING",tempstring)
					local tempstring = "Synthetic Silksteel > Avalons > Noodles > Cybernetics > Processor Cores > Spoofers > Everything else."
					ProcessEvent("MESSAGE_WAITING",tempstring)
				end
				if v=="combat" then
					combatmode=true
					local tempstring = "Combat Mode Initiated. Might do well to keep clear."
					ProcessEvent("MESSAGE_WAITING",tempstring)
					local tempstring = "Synthetic Silksteel > Avalons > Noodles > Cybernetics > Processor Cores > Spoofers > Everything else."
					ProcessEvent("MESSAGE_WAITING",tempstring)
				end
				if v=="specific" then
					prioritiesconsidered=true
					specificcargo=arg[i+1]
					local tempstring = ("Prioritising drops. Attempting to find : "..specificcargo)
					ProcessEvent("MESSAGE_WAITING",tempstring)
					local tempstring = "Synthetic Silksteel > Avalons > Noodles > Cybernetics > Processor Cores > Spoofers > Everything else."
					ProcessEvent("MESSAGE_WAITING",tempstring)
				end
			end
			dullbotcargocycle()
		elseif args==nil then
			prioritiesconsidered=false
			specificcargo=""
			local tempstring = "Collecting Closest First."
			ProcessEvent("MESSAGE_WAITING",tempstring)
			dullbotcargocycle()
		end
	end
end

-- Function : dullbotcargocycle
-- This is an ever repeating cycle to check if dullbot is active,
-- if it is not it will select a target and initiate its settings correctly.
-- calls targetselectionroutine.
function dullbotcargocycle()
	remoteresponsedullbotsuppression=true
	declare("remoteresponsedullbotsuppression",remoteresponsedullbotsuppression)
	local objecttype, objectid = radar.GetRadarSelectionID()
	local user=GetPlayerName()
	local charid = GetCharacterIDByName(user)
	local ship = GetPrimaryShipNameOfPlayer(charid)
	local shealth, shield = GetPlayerHealth(charid)
	if dullbotisrunning~=true and shealth ~= -1 then
		gkinterface.GKProcessCommand('targetnone')
		--local distance=GetTargetDistance()
		--if distance==nil then
			--print("latter cycle")
			if prioritiesconsidered==true and specificcargo~="" or nil then
				dbcctimer2:SetTimeout(100, function() gkinterface.GKProcessCommand('TargetCargo '..specificcargo) end)
			elseif prioritiesconsidered==true then
				--dbcctimer2:SetTimeout(100, targetselectionroutine)
				cargosort()
			else
				dbcctimer2:SetTimeout(100, function() gkinterface.GKProcessCommand('TargetCargo') end)
			end
		--end
	end
	if dullbotcargocollectortoggle==true then
		dbcctimer:SetTimeout(1000,dullbotcargocycle)
	else
		remoteresponsedullbotsuppression=false
		declare("remoteresponsedullbotsuppression",remoteresponsedullbotsuppression)
	end
end



-- Function : targetselectionroutine
-- Cycles through targets and attempts rudimentary prioritisation.
-- Calls checkforore, does not report back, simply leaves you with a target, or not,
-- However, in the event of no targets of value, it stops the collector.
function targetselectionroutine()
	selecttargetinfo=GetTargetInfo()
	if targettingtempcounter==0 then
		gkinterface.GKProcessCommand("targetnone")
		targettingtempcounter=1
		targetfound=false
		orecheckboolean=false
	elseif selecttargetinfo ~= nil then
		local tempstring=string.find(selecttargetinfo, "Scrap Metal")
		if tempstring==nil then
			targetfound=true
			targettingtempcounter=0
		else
			targetfound=false
			if targettingtempcounter==15 then
				targetfound=true
			end
		end
	end
	if targetfound==false then
		if targettingtempcounter>=8 then
			targettingtempcounter=targettingtempcounter+1
			gkinterface.GKProcessCommand("TargetCargo")
		end
		if selecttargetinfo==nil then
			if targettingtempcounter==7 then
				gkinterface.GKProcessCommand("TargetCargo")
				targettingtempcounter=8
			elseif targettingtempcounter==6 then
				gkinterface.GKProcessCommand("TargetCargo Spoofer")
				targettingtempcounter=7
			elseif targettingtempcounter==5 then
				gkinterface.GKProcessCommand("TargetCargo Core")
				targettingtempcounter=6
			elseif targettingtempcounter==4 then
				gkinterface.GKProcessCommand("TargetCargo Cybernetics")
				targettingtempcounter=5
			elseif targettingtempcounter==3 then
				gkinterface.GKProcessCommand("TargetCargo Nodule")
				targettingtempcounter=4
			elseif targettingtempcounter==2 then
				gkinterface.GKProcessCommand('TargetCargo Avalon')
				targettingtempcounter=3
			elseif targettingtempcounter==1 then
				local tempstringcounter=0
				while tempstringcounter<15 do
					gkinterface.GKProcessCommand("TargetCargo")
					local targetinfo=GetTargetInfo()
					if targetinfo then
						local tempstring=string.find(targetinfo, "Scrap Metal")
						if tempstring then
							tempstringcounter=tempstringcounter + 1
						else
							orecheckboolean=false
							checkforore()
							if orecheckboolean==false then
								tempstringcounter=15
							else
								tempstringcounter=tempstringcounter + 1
							end
						end
					else
						tempstringcounter=15
					end
				end
				local targetinfo=GetTargetInfo()
				local tempcargodistance=GetTargetDistance()
				if targetinfo then
					if tempcargodistance == nil or tempcargodistance < 1 then
						tempdistance = 1
					end
					if tempcargodistance > 2000 then
						gkinterface.GKProcessCommand("targetnone")
						dbcctimer2:SetTimeout(50, function() gkinterface.GKProcessCommand("TargetCargo Synthetic") end)
						targettingtempcounter=2
					elseif tempcargodistance <= 2000 then
						targetfound=true
					end
				else
					targettingtempcounter=2
				end
			end
		end
	end
	if targetfound==false then
		if targettingtempcounter<15 then
			dbcctimer5:SetTimeout(100,targetselectionroutine)
		end
	end
	if targettingtempcounter==15 or targetfound==true then
		if targetfound==false then
			dullbotcargocollector()
		end
		targetfound=false
		targettingtempcounter=0
		dbcctimer5:Kill()
		local name, health, dist = GetTargetInfo()
		if name then
			dist = math.ceil(dist)
			local tempmessage = ("Cargo Collector Approaching : "..name.." at "..dist.."m.") --
			ProcessEvent("MESSAGE_WAITING",tempmessage)
			dbcctimer3:SetTimeout(500, function() gkinterface.GKProcessCommand('dullbot getshiptypeauto approachcargo') end)
		else
			local tempmessage = ("Cargo Collector Reports : No Cargo Found")
			ProcessEvent("MESSAGE_WAITING",tempmessage)
			local tempmessage = "DELAYEDCOMMAND"
			ProcessEvent("MESSAGE_WAITING",tempmessage)
		end
	end
end

-- Function : checkforore
-- attempts to eliminate common ores as collection targets, 
-- reports boolean back to main function. Called by targetselectionroutine.
function checkforore() 
	local targetinfoore=GetTargetInfo()
	local tempstring=string.find(targetinfoore, "Ferric")
	if tempstring then
		orecheckboolean=true
	end
	local tempstring=string.find(targetinfoore, "Carbonic")
	if tempstring then
		orecheckboolean=true
	end
	local tempstring=string.find(targetinfoore, "Aquean")
	if tempstring then
		orecheckboolean=true
	end
	local tempstring=string.find(targetinfoore, "Vanazek")
	if tempstring then
		orecheckboolean=true
	end
	local tempstring=string.find(targetinfoore, "Silicate")
	if tempstring then
		orecheckboolean=true
	end
	local tempstring=string.find(targetinfoore, "Ishik")
	if tempstring then
		orecheckboolean=true
	end
end

function testnamestringclip()
	local name=GetTargetInfo()
	--print(name)
	local number = clipnametoquantity(name)
	--print(number)
end
local targetsscanned={}
function radarscantest()
	--if cat~=nil then
		--cat.toggle()
	--end
	targetless_off()
	targetsscanned={}
	local scanning = true
	local firstscan = true
	local objectscancount=0
	local firstobjectname = ""
	while scanning==true do
		if GetTargetInfo == firstobjectname then
			scanning = false
		end
		gkinterface.GKProcessCommand("RadarPrev")
		if GetTargetInfo() and scanning == true then
			objectscancount=objectscancount+1
			if firstscan==true then
				firstobjectname = GetTargetInfo()
			end
			local temptargetinfo=GetTargetInfo()
			local tempdist=GetTargetDistance()
			local nodeid,objectid = radar.GetRadarSelectionID()
			targetsscanned[objectscancount]={}
			targetsscanned[objectscancount]["name"] = temptargetinfo
			targetsscanned[objectscancount]["distance"] = tempdist
			targetsscanned[objectscancount]["objectid"] = objectid
			targetsscanned[objectscancount]["nodeid"] = nodeid
			applyweight(objectscancount)
		else
			scanning = false
		end
	end
	--print ("Scanned "..objectscancount.." radar objects.")
	targetless_on()
	--if cat~=nil then
		--cat.toggle()
	--end
end
RegisterUserCommand("cliptest",radarscantest)
function cargosort()
	gkinterface.GKProcessCommand("targetnone")
	radarscantest()
	local index = 0
	local mindist = 5000
	local weight = 0
	--local tempweight = 0
	for i, v in pairs(targetsscanned) do
		--local name = targetsscanned[i]["name"]
		--local distance = targetsscanned[i]["distance"]
		local tempweight = targetsscanned[i]["weight"]
		--print(name.." at "..distance.."m and weight of "..tempweight)
		if tempweight > weight then
				weight=tempweight
				index=i
		end
	end
	targetfound=false
	if index ~= 0 then
		local objectid=targetsscanned[index]["objectid"]
		local nodeid=targetsscanned[index]["nodeid"]
		--local name = targetsscanned[index]["name"]
		--local distance = math.floor(targetsscanned[index]["distance"])
		--local tempweight = math.floor(targetsscanned[index]["weight"])
		--print("Debugging: "..name.." at "..distance.."m and weight of "..tempweight)
		radar.SetRadarSelection(nodeid,objectid)
		-- Target via object id.
		targetfound=true
	end
	if targetfound==true then
		local name, health, dist = GetTargetInfo()
		if name then
			dist = math.ceil(dist)
			local tempweight = math.floor(targetsscanned[index]["weight"]) or 0
			local tempmessage = ("Cargo Collector Approaching : "..name.." at "..dist.."m. Debugging : Weight of "..tempweight) --
			ProcessEvent("MESSAGE_WAITING",tempmessage)
			dbcctimer3:SetTimeout(500, function() gkinterface.GKProcessCommand('dullbot getshiptypeauto approachcargo') end)
		end
	elseif targetfound==false then
		local tempmessage = ("Cargo Collector Reports : No Cargo Found")
		ProcessEvent("MESSAGE_WAITING",tempmessage)
		local tempmessage = "DELAYEDCOMMAND"
		ProcessEvent("MESSAGE_WAITING",tempmessage)
		dullbotcargocollector()
	end
end
RegisterUserCommand("cargosort",cargosort)
function applyweight(index)
	local name=targetsscanned[index]["name"]
	local distance=targetsscanned[index]["distance"]
	local weight = 0
	local tempnumber = clipnametoquantity(name)
	local number = tonumber(tempnumber)
	if string.find(name,"Synthetic Silksteel") then
		weight=20
	elseif string.find(name,"Nodule") then
		weight=100
	elseif string.find(name,"Core") then
		if string.find(name,"Queen") then
			weight=100
		elseif string.find(name,"Guardian") then
			weight=20
		elseif string.find(name,"Artemis") then
			weight=10
		else
			weight=15
		end
	elseif string.find(name,"Hive") then
		if string.find(name,"Gatling") then
			weight=50
		elseif string.find(name,"Posi") then
			weight=50
		elseif string.find(name,"Fast Charge") then
			weight=10
		else
			weight=3
		end
	elseif string.find(name,"Avalon") then
		weight=1.5
		number=number * 10
	elseif string.find(name,"Law Enforcement") then
		weight=50
	elseif string.find(name,"Spoofer") then
		weight=5
	elseif string.find(name,"Cybernetics") then
		weight=10
	elseif string.find(name,"Premium") then
		weight=0.1
	elseif string.find(name,"Scrap Metal") then
		weight=0.01
	else
		weight=3
	end
	local invertdist=0
	if distance ~= nil then
		invertdist=5000-distance
	end
	if number ~= nil then
		weight=(weight * invertdist) * (number)
	else
		weight=0
	end
	targetsscanned[index]["weight"]=weight
end
function printtargetscanned()
	local ai = 0
	local cargo = 0
	local roids=  0
	local other = 0
	for i,v in pairs(targetsscanned) do
		local name=targetsscanned[i]["name"]
		local distance=targetsscanned[i]["distance"]
		if string.find(name,"*") then
			ai=ai+1
		elseif string.find(name,"cu") then
			cargo=cargo+1
		elseif string.find(name,"roid") then
			roids=roids+1
		else
			other=other+1
		end
		local number = clipnametoquantity(name)
		if number~= nil then
			print (i..", "..name.." a quantity of "..number)
			local tempdist=targetsscanned[i]["distance"]
			if tempdist then
				print(tempdist.."m.")
			end
		else
			if string.find(name,"roid") then
				--skip
			else
				print (i..", "..name..", no quantity.")
				local tempdist=targetsscanned[i]["distance"]
				if tempdist then
					print(tempdist.."m.")
				end
			end
		end
	end
	print("Found : "..ai.." AI bots, "..cargo.." Cargo crates, "..roids.." Asteroids, and "..other.." Other objects.")
end
RegisterUserCommand("printtargets",printtargetscanned)
function clipnametoquantity(tempcargoname)
	if string.find(tempcargoname, "cu") then
		local a = string.find(tempcargoname, "%(")
		local a2 = string.find(tempcargoname, "%)")
		local numberstep1 = string.sub(tempcargoname, a, a2)
		local numberstep2=string.gsub(numberstep1,"%(","")
		local numberstep3=string.gsub(numberstep2,"%)","")
		local numberstep4=string.gsub(numberstep3,"cu","")
		local a = string.find(numberstep4, "x")
		local a2 = string.find(numberstep4, " ")
		local b = 1
		if a ~= nil then
			a=a-1
		end
		if a ~= nil then
			a2=a2+1
		end
		local quantity = 0
		local size = 0
		if a ~= nil then
			local tempstring=string.sub(numberstep4, b, a)
			local tempstring2=string.sub(numberstep4, a2)
			quantity=tonumber(tempstring)
			size=tonumber(tempstring2)
		else
			quantity=1
			size=tonumber(numberstep4)
		end
		--print ("Cargo is "..size.." cu, and a quantity of "..quantity..".")
		return(quantity)
	else
		return(nil)
	end
end




RegisterUserCommand("dullbotcargocollector",dullbotcargocollector)

