-- =====
-- Plod. -- LITE
-- =====
-- Author: INKling(truncated by Nyscersul)
--
-- Plod can be used to plot courses between two sectors. 
--
-- The trade item is case sensitive.
--
--
-- Usage.
-- ------
-- /dbplod [from sector] [to sector]
--
-- Examples:
-- ---------
-- /dbplod sol e15 geira i5
-- /dbplod . geira o4
-- /dbplod a12 j6




plod = plod or {}
resetmsgbooleantimer=Timer()
resetmsgbooleanfunc={}
function resetmsgbooleanfunc()
	remoteresponsedullbotsuppression=false
	declare("remoteresponsedullbotsuppression",remoteresponsedullbotsuppression)
end
plod.FORWARD = 1
plod.BACKWARD = 0

local dbtgotimer=Timer()
local dbgonavplot=false
local dbplodwaiting=false

plod.to = nil
plod.from = nil



-- ====================
-- Plod: get sector ID.
-- ====================
-- args
-- A list of arguments to parse. This function is destructive and removes
-- leading elements as it parses.
-- return
-- A sector ID or nil.
function plod.get_sector_id(args)
	if not args then
		return nil
	end
	local sector_id = nil
	local system_name = nil
	while sector_id == nil and # args > 0 do
		local arg = args[1]
		-- Current sector.
		if arg=="ed" then
			arg="edras"
		elseif arg=="pel" then
			arg="pelatus"
		elseif arg=="brac" then
			arg="bractus"
		elseif arg=="sed" then
			arg="sedina"
		elseif arg=="od" then
			arg="odia"
		elseif arg=="lat" then
			arg="latos"
		elseif arg=="uk" then
			arg="ukari"
		elseif arg=="hel" then
			arg="helios"
		elseif arg=="az" then
			arg="azek"
		elseif arg=="ac" then
			arg="arta"
		elseif arg=="dau" then
			arg="dau"
		elseif arg=="nyr" then
			arg="nyrius"
		elseif arg=="ver" then
			arg="verasi"
		elseif arg=="jal" then
			arg="jallik"
		elseif arg=="div" then
			arg="divinia"
		elseif arg=="aa" then
			arg="artana"
		elseif arg=="pher" then
			arg="pherona"
		elseif arg=="it" then
			arg="itan"
		elseif arg=="ss" then
			arg="setalli"
		elseif arg=="met" then
			arg="metana"
		elseif arg=="can" then
			arg="cantus"
		elseif arg=="eo" then
			arg="eo"
		elseif arg=="den" then
			arg="deneb"
		elseif arg=="gr" then
			arg="geira"
		elseif arg=="beth" then
			arg="betheshee"
		elseif arg=="sol" then
			arg="sol"
		elseif arg=="dan" then
			arg="dantia"
		elseif arg=="rha" then
			arg="rhamus"
		elseif arg=="pyr" then
			arg="pyronis"
		elseif arg=="ini" then
			arg="initros"
		end
		if arg == '.' or arg == 'current' then
		sector_id = GetCurrentSectorid()
		-- Sector definition.
		elseif arg:match("%a%-?%d") then
		if not system_name then
			system_name = string.gsub(SystemNames[GetCurrentSystemid()], '(%S+)%s*(%S*)', '%1')
		end
		sector_id = SectorIDFromLocationStr(system_name..' '..arg)
		-- System definition.
		elseif arg:match("%w+") then
			if not system_name then
				system_name = arg
			else
				return nil
			end
		else
		return nil
		end
		table.remove(args, 1)
	end
	return sector_id
end

function plod.start(from, to)
	remoteresponsedullbotsuppression=true
	declare("remoteresponsedullbotsuppression",remoteresponsedullbotsuppression)
	resetmsgbooleantimer:SetTimeout(5000,resetmsgbooleanfunc)
	plod.from = from
	plod.to = to
	local my_id = GetCharacterIDByName(GetPlayerName())
	local ship = GetPrimaryShipNameOfPlayer(my_id)
	if from==nil and to==nil then
		local tempstring=("Automated pilot failed to ascertain your destination or intermediary waypoint.")
		ProcessEvent("MESSAGE_WAITING",tempstring)
		local tempstring=("Try for example 'dbplod odia m14 bractus d9' to fly to Bractus D9 via Odia M14.")
		ProcessEvent("MESSAGE_WAITING",tempstring)
	elseif to==nil and from ~= nil then
		to=from
		local tempsector_id = GetCurrentSectorid()
		from=tempsector_id
		if to ~= tempsector_id then
			local tempstring=("Automated Pilot flying from (" .. LocationStr(from) .. ") to (" .. LocationStr(to) .. ") in "..ship)
			ProcessEvent("MESSAGE_WAITING",tempstring)
			gkinterface.GKProcessCommand("navroute clear")
			--NavRoute.SetFinalDestination(to)
			local tempstringa=("navroute add \""..LocationStr(to).."\"")
			--print(tempstringa)
			gkinterface.GKProcessCommand(tempstringa)
			dbgonavplot=true
			dbplodwaiting=true
			dbploddullbot()
		else
			local tempstring=("Automated Pilot is unsure of your intended destination.")
			ProcessEvent("MESSAGE_WAITING",tempstring)
			local tempstring=("Try for example 'dbplod . bractus d9' to fly to Bractus D9.")
			ProcessEvent("MESSAGE_WAITING",tempstring)
		end
	elseif to==nil then
		local tempstring=("Automated Pilot failed to ascertain your intended destination.")
		ProcessEvent("MESSAGE_WAITING",tempstring)
		local tempstring=("Try for example 'dbplod . bractus d9' to fly to Bractus D9.")
		ProcessEvent("MESSAGE_WAITING",tempstring)
	elseif from==nil then
		local tempstring=("Automated Pilot failed to ascertain your intended destination.")
		ProcessEvent("MESSAGE_WAITING",tempstring)
		local tempstring=("Try for example 'dbplod . bractus d9' to fly to Bractus D9.")
		ProcessEvent("MESSAGE_WAITING",tempstring)
	else
		local tempsector_id = GetCurrentSectorid()
		if from ~= tempsector_id then
			gkinterface.GKProcessCommand("navroute clear")
			local tempstring=("Automated Pilot flying you from ("..(LocationStr(tonumber(tempsector_id)))..") via ("..(LocationStr(tonumber(from)))..") to ("..(LocationStr(tonumber(to)))..") in "..ship)
			ProcessEvent("MESSAGE_WAITING",tempstring)
			local tempsector_id = GetCurrentSectorid()
			--NavRoute.SetFullRoute({from, to})
			local tempstringa=("navroute add \""..LocationStr(from).."\"")
			--print(tempstringa)
			gkinterface.GKProcessCommand(tempstringa)
			local tempstringa=("navroute add \""..LocationStr(to).."\"")
			--print(tempstringa)
			gkinterface.GKProcessCommand(tempstringa)
			dbgonavplot=true
			dbplodwaiting=true
			dbploddullbot()
		elseif from == tempsector_id then
			local tempstring=("Automated Pilot flying from (" .. LocationStr(from) .. ") to (" .. LocationStr(to) .. ") in "..ship)
			ProcessEvent("MESSAGE_WAITING",tempstring)
			--NavRoute.SetFinalDestination(to)
			gkinterface.GKProcessCommand("navroute clear")
			local tempstringa=("navroute add \""..LocationStr(to).."\"")
			--print(tempstringa)
			gkinterface.GKProcessCommand(tempstringa)
			dbgonavplot=true
			dbplodwaiting=true
			dbploddullbot()
		end
	end
end

function plod.commands(_,args)
	local from = plod.get_sector_id(args)
	local to = plod.get_sector_id(args)
	plod.start(from, to)
end
-- Wiring in to dullbot and navcomp to autoplot when appropriate
function dbploddullbot()
	if dbgonavplot==false and dbplodwaiting== false then
		if dullbotisrunning == true then
			gkinterface.GKProcessCommand("dullbot")
			gkinterface.GKProcessCommand("+brakes")
		end
		dbtgotimer:SetTimeout(2000, function() gkinterface.GKProcessCommand('dbtgo') end)
	elseif dbgonavplot==false and dbplodwaiting==true then
		if dullbotisrunning == true then
			gkinterface.GKProcessCommand("dullbot")
			gkinterface.GKProcessCommand("+brakes")
		end
		if navcompplottingcomplete==true then
			dbplodwaiting=false
		end
		dbtgotimer:SetTimeout(2000,dbploddullbot)
	elseif dbgonavplot==true and dbplodwaiting==true then
		local opt=""
		local my_id = GetCharacterIDByName(GetPlayerName())
		local ship = GetPrimaryShipNameOfPlayer(my_id)
		local cargo = GetActiveShipMaxCargo()
		if string.find(ship, "Trident") then
			opt="trident"
		elseif string.find(ship, "Goliath") then
			opt="goli"
		elseif cargo == 800 then
			opt="trident"
		elseif cargo==600 then
			opt="goli"
		end
		if opt=="" then
			navcompplottingcomplete=false
			dbgonavplot=false 
			dbplodwaiting=true
			gkinterface.GKProcessCommand("nc plot")
			dbtgotimer:SetTimeout(2000,dbploddullbot())
		elseif opt=="trident" or opt=="goli" then
			dbgonavplot=false 
			dbplodwaiting=false
			dbtgotimer:SetTimeout(2000,dbploddullbot())
		end
	end
end



RegisterUserCommand('dbplod', plod.commands)
