-- dullbot
-- small autopilot experiment

-- Copyright (c) 2008 Stefan Scheffler

-- Permission is hereby granted, free of charge, to any person
-- obtaining a copy of this software and associated documentation
-- files (the "Software"), to deal in the Software without
-- restriction, including without limitation the rights to use,
-- copy, modify, merge, publish, distribute, sublicense, and/or sell
-- copies of the Software, and to permit persons to whom the
-- Software is furnished to do so, subject to the following
-- conditions:

-- The above copyright notice and this permission notice shall be
-- included in all copies or substantial portions of the Software.

-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
-- EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
-- OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
-- NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
-- HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
-- WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-- FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
-- OTHER DEALINGS IN THE SOFTWARE.

local stoppingbraketimer=Timer() --- added by Nyscersul

--[[ Dullbot Recorder
dullbotrecorderactive=false
declare("dullbotrecorderactive",dullbotrecorderactive)
dullbotrecorderlocations={}
declare("dullbotrecorderlocations",dullbotrecorderlocations)
dullbotrecorderpath={}
declare("dullbotrecorderpath",dullbotrecorderpath)
dullbotrecorderpathstorecord={}
declare("dullbotrecorderpathstorecord",dullbotrecorderpathstorecord)
dullbotrecorderstep=0
declare("dullbotrecorderstep",dullbotrecorderstep)
dullbotrecorderstarttime=0
declare("dullbotrecorderstarttime",dullbotrecorderstarttime)
dullbotrecordersteprecording=false
declare("dullbotrecorderstep",dullbotrecorderstep)
dullbotrecordertimer=Timer()
dullbotrecordersystemnotes=54123
declare("dullbotrecordersystemnotes",dullbotrecordersystemnotes)
dullbotrecorderargs=""
declare("dullbotrecorderargs",dullbotrecorderargs)
]]-- placed here for reference only, should be correctly initialised in main.lua.


local cannontapsmove=0
local cannonordermove=1
local cannontimermove=Timer()

function firemissilesduringmove(time)
	if time >20 then
		cannontapsmove=8
	elseif time > 17.5 then
		cannontapsmove=7
	elseif time > 15 then
		cannontapsmove=6
	elseif time > 12.5 then
		cannontapsmove=5
	elseif time > 10 then
		cannontapsmove=4
	elseif time > 7.5 then
		cannontapsmove=3
	elseif time > 5 then
		cannontapsmove=2
	elseif time > 2.5 then
		cannontapsmove=1
	elseif time > 0 then
		cannontapsmove=0
	end
	cannontapcyclermove()
end

function cannontapcyclermove()
	if cannontapsmove > 0 then
		if cannonordermove==1 then
			gkinterface.GKProcesscommand("cannontap1")
			cannonordermove=2
		elseif cannonordermove==2 then
			gkinterface.GKProcesscommand("cannontap2")
			cannonordermove=3
		elseif cannonordermove==3 then
			gkinterface.GKProcesscommand("cannontap3")
			cannonordermove=4
		elseif cannonordermove==4 then
			gkinterface.GKProcesscommand("cannontap4")
			cannonordermove=1
		end
		cannontapsmove=cannontapsmove-1
		cannontimermove:SetTimeout(2500,cannontapcyclermove)
	end
end




brakesoff={}
brakingsequence={}
turnoffbrakes={}
local brakesinterrupted=false
turboboolean=false
local _

rollingsequence={}
rollingactive=false
rollingamount=0
rollingsequencetimer=Timer()
rollingdirection="positive"

function rollingsequence()
	if rollingamount > 1000 then
		rollingdirection="negative"
		rollingamount=1000
	elseif rollingamount < -1000 then
		rollingdirection="positive"
		rollingamount=-1000
	end
	gkinterface.GKProcessCommand("roll "..rollingamount)
	if rollingdirection=="positive" then
		rollingamount=rollingamount+10
	elseif rollingdirection=="negative" then
		rollingamount=rollingamount-10
	end
	local timeout=1
	if rollingamount==1000 then
		timeout=1000
	elseif rollingamount==-1000 then
		timeout=1000
	else
		timeout=30
	end
	if rollingactive==true then
		rollingsequencetimer:SetTimeout(timeout,rollingsequence)
	else
		gkinterface.GKProcessCommand("roll 0")
	end
end

function inturret()
	local turret = 0
	local inturretboolean=false
	for turret = 1, 4, 1 do
		local sti={}
		sti=GetStationTurretInfo(turret)
		if sti==nil then
			inturretboolean=false
		else
			if sti.controller == GetCharacterIDByName(GetPlayerName()) then
				inturretboolean=true
			end
		end
	end
	return inturretboolean
end

local finder = dofile("dullbot/objectfinder.lua")

-- plugin directory
-- relative to game directory
local PLUGIN_DIR = "plugins/RemotePilot/dullbot"

-- how long to spin. does not include time to brake
-- should be long enough to spin the ship by slightly more than 90
-- if too large the bot will have trouble hitting the gate
local DEFAULT_SPIN_DURATION = 1

-- DEFAULT_SPIN_DURATION is multiplied by this value to get the time to brake
-- the bot estimates this from the ships description unless 
-- DEFAULT_BRAKE_FACTOR_MANUAL is true
local DEFAULT_BRAKE_FACTOR = 5
local DEFAULT_BRAKE_FACTOR_MANUAL = false

-- how long in seconds to move between centering checks
local DEFAULT_MOVE_DURATION = 30

-- tolerance for gate centering in percent
-- if too large the bot will have to do lots of course corrections
-- if too small it will have trouble hitting the gate and waste time on exit points
local DEFAULT_TOLERANCE = 0.2

-- area around object where not to use turbo
-- bot may still boost for up to a second after entering this zone
local DEFAULT_NO_TURBO_ZONE = -2

-- disable controls while the bot is active
-- without this wobbly joysticks will make the bot drift
local DEFAULT_DISABLE_INPUT = false

-- these should be correct for all available ships
local TURN_DAMP = 4
local SPIN_SPEED = 1000

-- collision avoidance stuff
local DEFAULT_TARGET = false
local DEFAULT_AVOID = false

-- show unneeded radar blibs (station and ships) while taking screenshots
local DEFAULT_BLIBS = false

-- use larger blibs
local DEFAULT_LARGEBLIBS = false

-- approach/pickup mode
local DEFAULT_APPROACH_MODE = false

local DEFAULT_HIGH_ACCURACY_DIST = 100

local MIN_AVOIDANCE_DISTANCE = 100 -- below this targeting gets less reliable
local MAX_AVOIDANCE_DISTANCE = 400 -- above this target could be a false positive
local AVOIDANCE_STEP_DELAY = 3000 -- delay between each step for collision avoidance

-- sector types
local ST_DEST = 1 -- destination
local ST_GATE = 2 -- have to enter a gate
local ST_OTHER = 3 -- nav point or new system
local ST_STORM = 4

local dullbot = {}

-- return values
dullbot.BOT_ARRIVED = nil
dullbot.BOT_STUCK = 1
dullbot.BOT_DIED = 2
dullbot.BOT_DOCKED = 3
dullbot.BOT_ABORT = 4
dullbot.BOT_DISCONNECTED = 5
dullbot.BOT_TARGET_LOST = 6


function dullbot.new()
	local instance = {}

	-- local variables
	local opt_serverdir = PLUGIN_DIR
	
	local opt_tolerance = DEFAULT_TOLERANCE
	local opt_exit_tolerance = DEFAULT_TOLERANCE

	local opt_spin_duration = DEFAULT_SPIN_DURATION
	local opt_move_duration = DEFAULT_MOVE_DURATION
	local opt_no_turbo_zone = DEFAULT_NO_TURBO_ZONE

	local opt_disable_input = DEFAULT_DISABLE_INPUT

	local opt_brake_factor_manual = DEFAULT_BRAKE_FACTOR_MANUAL
	local opt_brake_factor = DEFAULT_BRAKE_FACTOR

	local opt_target = DEFAULT_TARGET
	local opt_avoid = DEFAULT_AVOID
	local opt_blibs = DEFAULT_BLIBS
	local opt_largeblibs = DEFAULT_LARGEBLIBS

	local opt_approach_mode = DEFAULT_APPROACH_MODE
	local opt_high_accuracy_dist = DEFAULT_HIGH_ACCURACY_DIST

	local targetdata = nil
	local blib_correction = 0
	local init = false
	local running = false
	local activate_turbo = false
	local bot_cb = nil
	
	local blibscale = 1

	instance.finder = finder.new()


	local function roboprint(str)
		print("\127ffffff"..tostring(str))
	end

	-- determine current sector type
	local function sectortype()
		--print("checking sector type")
		if NavRoute.GetNextHop() == GetCurrentSectorid() then
			return ST_DEST
		elseif SplitSectorID(NavRoute.GetNextHop()) ~= SplitSectorID(GetCurrentSectorid()) then
			return ST_GATE
		elseif IsStormPresent() then
			return ST_STORM
		else
			return ST_OTHER
		end
	end

	local function isrunning()
		if init and running and GetActiveShipID() then
			return true
		end
	end

	local function get_brake_factor()
		local shipid = GetActiveShipID()
		if not shipid then
			roboprint("no active ship. using default brake factor")
			return DEFAULT_BRAKE_FACTOR
		end
		
		local torque = tonumber(GetInventoryItemExtendedDesc(shipid):gmatch("Spin torque: (.*) Nm")())
		if not torque then
			roboprint("can't get spin torque. using default brake factor")
			return DEFAULT_BRAKE_FACTOR
		end

		return torque / TURN_DAMP 
	end

	local function get_radar()
		return iup.GetBrother(iup.GetParent(HUD.leftradarlabel))
	end

	-- rescale radar blibs
	local function largeblibs_set()
		local radar = get_radar()
		blibscale = tonumber(radar.BLIPSCALE)

		radar.BLIPSCALE = 2

		-- blibscale * iconsize / 2 
		blib_correction = 0-(tonumber(radar.BLIPSCALE) * 8)
	end

	local function largeblibs_reset()
		local radar = get_radar()
		radar.BLIPSCALE = blibscale

		-- blibscale * iconsize / 2 
		blib_correction = tonumber(radar.BLIPSCALE) * 8
	end


	-- GetNearestObjectDistance returns -1 if no objects are around
	-- pretend that there's one just outside the jump distance
	-- it's a bit friendlier for my use case
	local function object_distance_for_jump()
		if radar.GetNearestObjectDistance() >= 0 then
			return radar.GetNearestObjectDistance()
		else
			return GetMinJumpDistance() + 1
		end
	end

	local function object_near()
		local distance = radar.GetNearestObjectDistance()
		if distance >= 0 and distance < GetMinJumpDistance() then
			return true
		end
	end

	local function stop_ship()
		if dullbotrecorderactive==true then
			local tempstring="pitch 0"
			dullbotrecorderstepadvance(tempstring)
		end
		gkinterface.GKProcessCommand("pitch 0")
		if dullbotrecorderactive==true then
			local tempstring="turn 0"
			dullbotrecorderstepadvance(tempstring)
		end
		gkinterface.GKProcessCommand("turn 0")
		if dullbotrecorderactive==true then
			local tempstring="roll 0"
			dullbotrecorderstepadvance(tempstring)
		end
		gkinterface.GKProcessCommand("roll 0")
		if dullbotrecorderactive==true then
			local tempstring="+StrafeUp 0"
			dullbotrecorderstepadvance(tempstring)
		end
		gkinterface.GKProcessCommand("+StrafeUp 0")
		if dullbotrecorderactive==true then
			local tempstring="+StrafeLeft 0"
			dullbotrecorderstepadvance(tempstring)
		end
		gkinterface.GKProcessCommand("+StrafeLeft 0")
		if dullbotrecorderactive==true then
			local tempstring="+StrafeRight 0"
			dullbotrecorderstepadvance(tempstring)
		end
		gkinterface.GKProcessCommand("+StrafeRight 0")
		if dullbotrecorderactive==true then
			local tempstring="+StrafeDown 0"
			dullbotrecorderstepadvance(tempstring)
		end
		gkinterface.GKProcessCommand("+StrafeDown 0")
		if dullbotrecorderactive==true then
			local tempstring="it off"
			dullbotrecorderstepadvance(tempstring)
		end
		gkinterface.GKProcessCommand("it off")
		turboboolean=false
		if dullbotrecorderactive==true then
			local tempstring="+turbo 0"
			dullbotrecorderstepadvance(tempstring)
		end
		gkinterface.GKProcessCommand("+turbo 0")
		brakingsequence()
	end

	local function blocking_object_targeted()
		if GetTargetDistance() and GetTargetDistance() < MAX_AVOIDANCE_DISTANCE then
			return true
		end
	end


	function instance:turn_from_target(cb)
		local away_timer = Timer()
		gkinterface.GKProcessCommand("RadarNextFront")
		gkinterface.GKProcessCommand("turn -"..SPIN_SPEED)
		
		local function away_cb()
			if not isrunning() then
				return
			end

			if blocking_object_targeted() then
				gkinterface.GKProcessCommand("RadarNextFront")
				away_timer:SetTimeout(100)
			else
				stop_ship()
				away_timer:SetTimeout(AVOIDANCE_STEP_DELAY, cb)
			end
		end
		away_timer:SetTimeout(100, away_cb)
	end

	function instance:avoid(cb)
		local function turn_cb()
			self:move(cb, 4000)
		end
		self:turn_from_target(turn_cb)
	end
	

	-- change and restore control settings
	function instance:change_control_settings()
		if opt_disable_input then 
			Game.DisableInput() 
		end

		-- TODO: enable radar too
		self.mouselook = gkinterface.GetMouseLookMode()
		self.flightmode = Game.GetCVar("flymodeflag")
		self.navpoint = Show3000mNavpoint


		gkinterface.SetMouseLookMode(false)
		if self.flightmode==0 then
			Game.SetCVar("flymodeflag", 1)
		end
		radar.Show3000mNavpoint()
	end

	function instance:restore_control_settings()
		gkinterface.SetMouseLookMode(self.mouselook)
		Game.SetCVar("flymodeflag", self.flightmode)
		Show3000mNavpoint = self.navpoint

		if opt_disable_input then
			Game.EnableInput()
		end
	end

	-- move ship
	-- if accel_time ~= nil stop ship after accel_time and call cb
	function instance:move(cb, move_duration)
		if not isrunning() then
			return
		end
		if dullbotrecorderactive==true then
			local tempstring="Game.SetDesiredSpeed(100)"
			dullbotrecorderstepadvance(tempstring)
		end
		Game.SetDesiredSpeed(100)
		
		activate_turbo = true

		if cb and move_duration then
			-- measure how long it takes to accelerate to close to top speed
			-- kinda crappy
			local accel_time = 1000

			local accel_timer = Timer()

			local function accel_timer_cb()
				if not isrunning() then
					return
				end

				if GetActiveShipSpeed() < GetActiveShipMaxSpeed() - 5 then --changed?
					accel_time = accel_time + 1000 
					accel_timer:SetTimeout(1000)
				end		
			end
			accel_timer:SetTimeout(1000, accel_timer_cb)

			local move_timer = Timer()
			local function move_timer_cb()
				-- stop the acceleration time timer
				-- in case move_duration is shorter than
				-- the time to accel to full speed
				accel_timer:Kill()

				activate_turbo = false

				--Game.SetDesiredSpeed(0)
				local tempbooleanargs=false
				if string.find(dullbotreconstructedargs, "approachroid") then
					tempbooleanargs=true
				end
				if tempbooleanargs==false then
					brakingsequence()
				end
				-- TODO: poll GetActiveShipSpeed()
				local brake_timer = Timer()
				local temp_accel_time
				temp_accel_time=accel_time
				accel_time=accel_time/2
				brake_timer:SetTimeout(accel_time, cb)
				accel_time=temp_accel_time
			end
			
			local temp_move_duration=0
			if dullbotapproachcargomode==true or dullbotapproachroidmode==true then
				local distance = GetTargetDistance()
				if capitalshippilot==false then
					distance = distance / 2.2
				end
				if distance ~= nil then
					if distance > 5000 then
						temp_move_duration = 45
					elseif distance > 4500 then
						temp_move_duration = 40
					elseif distance > 4000 then
						temp_move_duration = 37
					elseif distance > 3500 then
						temp_move_duration = 35
					elseif distance > 3000 then
						temp_move_duration = 30
					elseif distance > 2500 then
						temp_move_duration = 25
					elseif distance > 2000 then
						temp_move_duration = 20
					elseif distance > 1500 then
						temp_move_duration = 15
					elseif distance > 1000 then
						temp_move_duration = 10
					elseif distance > 750 then
						temp_move_duration = 10
					elseif distance > 700 then
						temp_move_duration = 8
					elseif distance > 650 then
						temp_move_duration = 7
					elseif distance > 600 then
						temp_move_duration = 6
					elseif distance > 550 then
						temp_move_duration = 5
					elseif distance > 500 then
						temp_move_duration = 5
					elseif distance > 450 then
						temp_move_duration = 4
					elseif distance > 300 then
						temp_move_duration = 4
					elseif distance > 250 then
						temp_move_duration = 3
					elseif distance > 200 then
						temp_move_duration = 3
					elseif distance > 150 then
						temp_move_duration = 2
					elseif distance > 100 then
						temp_move_duration = 2
					elseif distance > 50 then
						temp_move_duration = 1
					end
				end
				temp_move_duration=temp_move_duration * 1000
			end
			if temp_move_duration == 0 then
				temp_move_duration = move_duration
			end
			if firemissilesduringcollection==true then
				firemissilesduringmove(temp_move_duration)
			end
			if temp_move_duration < 1000 then
				temp_move_duration = 1000
			end
			move_timer:SetTimeout(temp_move_duration, move_timer_cb)
		end
	end



	function instance:unstuckify(cb)
		Game.SetCVar("flymodeflag", 0)
		if dullbotrecorderactive==true then
			local tempstring="pitch 1000; wait 2000 \"pitch 0\""
			dullbotrecorderstepadvance(tempstring)
		end
		gkinterface.GKProcessCommand("pitch 1000; wait 2000 \"pitch 0\"")
		local unstuckify_timer = Timer()
		local function unstuckify_timer_cb2()
			if not isrunning() then return end
			Game.SetCVar("flymodeflag", 1)
			cb()
		end
		local function unstuckify_timer_cb()
			if not isrunning() then return end
			gkinterface.GKProcessCommand("turn 1000; wait 2000 \"turn 0\"")
			if dullbotrecorderactive==true then
				local tempstring="turn 1000; wait 2000 \"turn 0\""
				dullbotrecorderstepadvance(tempstring)
			end
			unstuckify_timer:SetTimeout(2000, unstuckify_timer_cb2)
		end
		unstuckify_timer:SetTimeout(2000, unstuckify_timer_cb)
		if dullbotapproachcargomode==false then
			if dullbotrecorderactive==true then
				local tempstring="+brakes 0"
				dullbotrecorderstepadvance(tempstring)
			end
			Game.SetDesiredSpeed(100)
		end
	end

	function instance:move_to_object(objecttype)
		if not isrunning() then 
			return
		end
		--local maxspeed=GetActiveShipMaxSpeed()
		--maxspeed=maxspeed-5
		if GetActiveShipSpeed() < 1 then      --> maxspeed then --- changed from < 1
			local function find_cb(found)
				if not isrunning() then
					return
				end

				if found == finder.FIND_CONERROR then
					if objecttype == finder.OT_TARGET then
						self:uninit()
						if bot_cb then bot_cb(dullbot.BOT_TARGET_LOST) end
						return
					end
					
					if sectortype() == ST_OTHER then
						roboprint("Couldn't find Navpoint. Using dumb mode")
						self:move()
					else
						roboprint("Couldn't find object and no fallback available. giving up")
						self:uninit()
						if bot_cb then bot_cb(dullbot.BOT_STUCK) end
					end
					return
				elseif found == finder.FIND_LOST then
					if objecttype == finder.OT_DOCK then
						roboprint("Lost docking bay out of sight")
						self:move_to_object(objecttype)
					else
						if bot_cb then bot_cb(dullbot.BOT_TARGET_LOST) end
					end
					return
				elseif found == finder.FIND_STUCK then
					local function unstuckify_cb()
						self:move_to_object(objecttype)
					end

					self:unstuckify(unstuckify_cb)
					return
				end
				
				-- bot is centered now move for move_duration
				-- towards it and then call parent again
				local duration = opt_move_duration * 1000

				if objecttype == finder.OT_TARGET or objecttype == finder.OT_DOCK then

					
					-- don't think this can actually heppen
					if GetTargetInfo() then
						local nodeid,objectid=radar.GetRadarSelectionID()
						if objectid~= dullbotapproachtarget.objectid then
							dullbotapproachtarget.objectidtemp=objectid
							dullbotapproachtarget.nodeidtemp=nodeid
						end
					end
					if dullbotapproachtarget.objectid~=0 then
						radar.SetRadarSelection(dullbotapproachtarget.nodeid,dullbotapproachtarget.objectid)
					end
					local targetdistance = GetTargetDistance()
					if not targetdistance then
						if dullbotapproachtarget.objectidtemp~=0 then
							radar.SetRadarSelection(dullbotapproachtarget.nodeidtemp,dullbotapproachtarget.objectidtemp)
							dullbotapproachtarget.objectidtemp=0
							dullbotapproachtarget.nodeidtemp=0
						end
						--self:uninit() debug
						--if bot_cb then 
							--bot_cb(dullbot.BOT_TARGET_LOST) 
						--end
						--return
					-- XXX redundant at the moment
					elseif targetdistance <= 100 then
						duration = duration / 5
					-- scale down move duration in no turbo zone
					elseif targetdistance < opt_no_turbo_zone then
						-- not perfectly scaled
						-- but it's enough for this thing
						local range = opt_no_turbo_zone - 100
						local rangedistance = targetdistance - 100
						
						local fraction = rangedistance / range
						if fraction < 0.2 then
							fraction = 0.2
						end
						
						duration = duration * fraction
					end
				end
				
				local function move_cb()
					self:move_to_object(objecttype)
				end
				self:move(move_cb, duration)
			end
			if inturret()==true then
				local speed_timer = Timer()
				local function turret_move_delay()
					if not isrunning() then
						return
					end
					self:move_to_object(objecttype)
				end
				speed_timer:SetTimeout(10, turret_move_delay)
				--print("Debug - delayed dump due to turret activation")
			elseif objecttype == finder.OT_GATE then
				self.finder:find(objecttype, nil, opt_tolerance, opt_spin_duration, opt_brake_factor, find_cb)
			elseif objecttype == finder.OT_EXIT then
				self.finder:find(objecttype, nil, opt_exit_tolerance, opt_spin_duration, opt_brake_factor, find_cb)
			elseif objecttype == finder.OT_TARGET or objecttype == finder.OT_DOCK then
				local tempdistance = GetTargetDistance() or 5000
				if tempdistance < opt_high_accuracy_dist then
					self.finder:find(objecttype, targetdata, opt_tolerance / 2, opt_spin_duration, opt_brake_factor, find_cb)
				else
					self.finder:find(objecttype, targetdata, opt_tolerance, opt_spin_duration, opt_brake_factor, find_cb)
				end
			else
				roboprint("unknown object type!")
			end
		else
			-- wait till the bot has stopped
			--Game.SetDesiredSpeed(0) --modified
			--local tempbooleanargs=false
			--if string.find(dullbotreconstructedargs, "approachroid") then
				--tempbooleanargs=true
			--end
			--print("braking")
			--if tempbooleanargs==false then
				--brakingsequence()
			--end
			brakingsequence()
			local speed_timer = Timer()
			local function speed_timer_cb()
				if not isrunning() then
					return
				end
				self:move_to_object(objecttype)
			end
			speed_timer:SetTimeout(1000, speed_timer_cb)
		end
	end


	function instance:uninit()
		UnregisterEvent(self, "PLAYER_DIED")
		UnregisterEvent(self, "ENTERING_STATION")
		UnregisterEvent(self, "SERVER_DISCONNECTED")

		self:restore_control_settings()
		self:stop()

		if not opt_blibs then
			--gkinterface.GKProcessCommand("radarshow 4 5 9 11")
		end

		if opt_largeblibs then
			largeblibs_reset()
		end

		init = false
	end


	-- clean up
	function instance:stop()
		running = false
		activate_turbo = false

		UnregisterEvent(self, "WARP_OUT_CINEMATIC_FINISHED")
		UnregisterEvent(self, "PLAYER_ENTERED_SECTOR")

		self.finder:Stop()

		stop_ship()
	end


	-- start the bot
	function instance:start()
		--print("debug - bot starting")
		local start_timer = Timer()

		-- try to target the dock before doing the success check
		-- XXX this is a shitty place for this
		if targetdata and targetdata.dock then
			radar.SetRadarSelection(2, targetdata.dock)
		end

		
		local function start_timer_cb()
			if not init then
				return
			end

			if not GetActiveShipID() then
				return
			end

			-- success conditions
			if opt_approach_mode then
				DEFAULT_NO_TURBO_ZONE = -1
				local target_distance = GetTargetDistance()
				if not target_distance then
					if approachobjectid~=0 then
						radar.SetRadarSelection(approachobjecttype, approachobjectid)
					else
						if remoteresponsedullbotsuppression==false then
							local tempmessage = "lost target.."
							ProcessEvent("MESSAGE_WAITING",tempmessage)
						end
						if dullbotcargocollectortoggle==true then
							local tempmessage = "Cargo Collected"
							ProcessEvent("MESSAGE_WAITING",tempmessage)
						end
						--roboprint("lost target..")
						self:uninit()
						if bot_cb then bot_cb(dullbot.BOT_TARGET_LOST) end
						return
					end
				elseif target_distance < opt_approach_mode then
					self:uninit()
					if bot_cb then bot_cb() end
					return
				end
			elseif sectortype() == ST_DEST then
				self:uninit()
				if bot_cb then bot_cb() end
				return
			end


			local _, elevel = GetActiveShipEnergy()

			if not isrunning() then
				-- the game returns crap if you try to get ship stats 
				-- during sector load HUD.IsVisible is a pretty crude check
				-- but the bot doesn't work without the hud anyway..
				if HUD.IsVisible and elevel > 0.25 then
					running = true

					RegisterEvent(self, "WARP_OUT_CINEMATIC_FINISHED")
					
					if opt_approach_mode then
						if targetdata and targetdata.dock then
							self:move_to_object(finder.OT_DOCK)
						else
							self:move_to_object(finder.OT_TARGET)
						end
					elseif sectortype() == ST_GATE then
						brakingsequence()
						--print("I'm in a gate sector!")
						self:move_to_object(finder.OT_GATE)
					elseif object_near() then
						brakingsequence()
						 --print("I'm not in a gate sector!")
						self:move_to_object(finder.OT_EXIT)
					end
				end

			-- call Activate only when it's really needed
			-- TODO: read from the chat receiver if I'm on a gate or something
			--       could be unreliable though
			elseif not opt_approach_mode then
				if sectortype() == ST_GATE and object_near() then
					if dullbotrecorderactive==true then
						local tempstring="Activate"
						dullbotrecorderstepadvance(tempstring)
					end
					if turboactivewh==false then
						gkinterface.GKProcessCommand("Activate")
					end
				elseif (sectortype() == ST_OTHER or sectortype() == ST_STORM) and not object_near() then
					if dullbotrecorderactive==true then
						local tempstring="Activate"
						dullbotrecorderstepadvance(tempstring)
					end
					gkinterface.GKProcessCommand("Activate")
				end
			end

			-- turbo stuff
			-- activate_turbo is set while accelerating and while at full speed

			-- only start boosting when energy is full
			-- that gets among other things around this strange "turbo doesn't
			-- work when active before jump" problem (hopefully)
			-- also makes non infiniboost ships work .. kinda

			-- if the bot is within no_turbo_zone meters of a large object
			-- turbo is disabled except when opt_target is set,

			-- if opt_avoid is set and somethings targeted within no_turbo_zone
			-- do some funky maneuvering unless it's already too close
			-- TODO: back off if too close

			local do_turbo = false
			if isrunning() and activate_turbo and elevel >= 0.5 then
				if opt_approach_mode and GetTargetDistance() < opt_no_turbo_zone then
					do_turbo = false
				elseif turboactivewh==false then
					do_turbo = false
				elseif object_distance_for_jump() > opt_no_turbo_zone then
					-- open space
					do_turbo = true
				elseif not opt_target then
					-- targeting disabled. disable turbo unconditionally in nfz 
					do_turbo = false
				elseif object_distance_for_jump() < MIN_AVOIDANCE_DISTANCE then
					-- too late to avoid object, keep going without turbo
					do_turbo = false
				elseif opt_avoid and blocking_object_targeted() then
					-- have something targeted and it's not too close. try to avoid it
					-- quick and dirty collision avoidance
					-- stop->wait->turn_from_target->wait->move->wait->restart
					self:stop()
					
					
					-- wait a moment till ship has fully stopped
					local pre_avoid_timer = Timer()
					local function pre_avoid_timer_cb()
						local function avoid_cb()
							self:start()
						end
						self:avoid(avoid_cb)
					end

					pre_avoid_timer:SetTimeout(AVOIDANCE_STEP_DELAY, pre_avoid_timer_cb)
					
					return
				else
					-- probably got past object. should be safe to enable turbo again
					do_turbo = true
				end
			end
			
			if isrunning() then
				if opt_target then
					gkinterface.GKProcessCommand("RadarNextFront")
				end

				if do_turbo then
					if turboboolean==false then
						--stoppingbraketimer:Kill()
						if dullbotrecorderactive==true then
							local tempstring="+brakes 0"
							dullbotrecorderstepadvance(tempstring)
						end
						gkinterface.GKProcessCommand("+brakes 0")
						--print("debug - stop braking early")
						if dullbotrecorderactive==true then
							local tempstring="it on"
							dullbotrecorderstepadvance(tempstring)
						end
						gkinterface.GKProcessCommand("it on")
						if dullbotrecorderactive==false and capitalshippilot==true then
							--gkinterface.GKProcessCommand("roll 1000")
							rollingactive=true
							rollingsequence()
						end
						turboboolean=true
					end
				else
					if turboboolean==true then
						if dullbotrecorderactive==true then
							local tempstring="it off"
							dullbotrecorderstepadvance(tempstring)
						end
						gkinterface.GKProcessCommand("it off")
						if dullbotrecorderactive==true then
							local tempstring="roll 0"
							dullbotrecorderstepadvance(tempstring)
						end
						gkinterface.GKProcessCommand("roll 0")
						turboboolean=false
					end
					if dullbotrecorderactive==true then
						local tempstring="roll 0"
						dullbotrecorderstepadvance(tempstring)
					end
					rollingactive=false
					gkinterface.GKProcessCommand("roll 0")
				end
			end

			start_timer:SetTimeout(1000)
		end

		-- timer keeps track of location and triggers jumps
		start_timer:SetTimeout(1000, start_timer_cb)
	end

	-- have to reset bot after each jump
	function instance:OnEvent(name, data)
		-- TODO maybe choose better event
		if name == "WARP_OUT_CINEMATIC_FINISHED" then
			--print("Debug : WARP_OUT_CINEMATIC_FINISHED")
			self:stop()
			RegisterEvent(self, "PLAYER_ENTERED_SECTOR")
		elseif name == "PLAYER_ENTERED_SECTOR" and data == GetCharacterID() then
			--print("Debug : PLAYER_ENTERED_SECTOR")
			self:start()
			--gkinterface.GKProcessCommand("dbtgo")
			UnregisterEvent(self, "PLAYER_ENTERED_SECTOR")
		elseif name == "PLAYER_DIED" then
			--print("Debug : PLAYER_DIED")
			self:uninit()
			if bot_cb then bot_cb(dullbot.BOT_DIED) end
		elseif name == "ENTERING_STATION" then
			--print("Debug : PLAYER_DIED")
			self:uninit()
			if bot_cb then bot_cb(dullbot.BOT_DOCKED) end
		elseif name == "SERVER_DISCONNECTED" then
			--print("Debug : SERVER_DISCONNECTED")
			self:uninit()
			if bot_cb then bot_cb(dullbot.BOT_DISCONNECTED) end
		end
	end

	-- interface
	function instance:IsRunning()
		return init
	end

	function instance:Init(cb)
		if init then
			return "bot already initialized"
		else
			if GetStationName() then
				return "can't start bot while docked"
			end

			init = true

			-- setup radar blibs and correction
			if opt_largeblibs then
				largeblibs_set()
			else
				local radar = get_radar()
				blib_correction = tonumber(radar.BLIPSCALE) * 4   --tonumber(radar.BLIPSCALE) * 8 -----modified
			end


			if not opt_brake_factor_manual then
				opt_brake_factor = get_brake_factor()
			end

			if not opt_blibs then
				--gkinterface.GKProcessCommand("radarhide 4 5 9 11")  ---radardebug
			end

			self.finder:SetBlibCorrection(blib_correction)
			self.finder:Init(opt_serverdir)

			bot_cb = cb
			
			RegisterEvent(self, "PLAYER_DIED")
			RegisterEvent(self, "ENTERING_STATION")
			RegisterEvent(self, "SERVER_DISCONNECTED")

			stop_ship()
			self:change_control_settings()
			self:start()
		end
	end

	function instance:Abort()
		if init then
			self:uninit()
			if bot_cb then bot_cb(dullbot.BOT_ABORT) end
		end
	end	

	-- config
	function instance:ResetConfig()
		opt_serverdir = PLUGIN_DIR
	
		opt_tolerance = DEFAULT_TOLERANCE
		opt_exit_tolerance = DEFAULT_TOLERANCE

		opt_spin_duration = DEFAULT_SPIN_DURATION
		opt_move_duration = DEFAULT_MOVE_DURATION
		opt_no_turbo_zone = DEFAULT_NO_TURBO_ZONE

		opt_disable_input = DEFAULT_DISABLE_INPUT

		opt_brake_factor_manual = DEFAULT_BRAKE_FACTOR_MANUAL
		opt_brake_factor = DEFAULT_BRAKE_FACTOR

		opt_target = DEFAULT_TARGET
		opt_avoid = DEFAULT_AVOID
		opt_blibs = DEFAULT_BLIBS

		opt_approach_mode = DEFAULT_APPROACH_MODE

		opt_high_accuracy_dist = DEFAULT_HIGH_ACCURACY_DIST
	end


	function instance:Tolerance(hole_tolerance, exit_tolerance)
		if tonumber(hole_tolerance) and hole_tolerance > 0 then
			opt_tolerance = hole_tolerance

			if tonumber(exit_tolerance) and exit_tolerance > 0 then
				opt_exit_tolerance = exit_tolerance
			else
				opt_exit_tolerance = hole_tolerance
			end
		end
		return opt_tolerance, opt_exit_tolerance
	end

	function instance:MoveDuration(duration)
		if tonumber(duration) and duration > 0 then
			opt_move_duration = duration
		end
		return opt_move_duration
	end

	function instance:SpinDuration(duration)
		if tonumber(duration) and duration > 0 then
			opt_spin_duration = duration
		end
		return opt_spin_duration
	end

	function instance:NoTurboZone(size)
		if tonumber(size) then
			opt_no_turbo_zone = size
		end
		return opt_no_turbo_zone
	end

	function instance:SpinBrakeFactor(factor)
		if tonumber(factor) then
			if factor > 0 then
				opt_brake_factor_manual = true
				opt_brake_factor = factor
			else
				opt_brake_factor_manual = false
				opt_brake_factor = DEFAULT_BRAKE_FACTOR
			end
		end
		return opt_brake_factor_manual, opt_brake_factor
	end

	function instance:SetDisableInput(input)
		opt_disable_input = input
	end	

	function instance:SetTarget(target)
		opt_target = target
	end

	function instance:SetAvoid(avoid)
		opt_avoid = avoid
	end

	function instance:SetRadarBlibs(blibs)
		opt_blibs = blibs
	end

	function instance:SetLargeBlibs(large)
		opt_largeblibs = large
	end

	function instance:SetServerDirectory(dir)
		if tostring(dir) then
			opt_serverdir = dir
		end
	end

	function instance:SetApproachMode(distance)
		if tonumber(distance) then
			opt_approach_mode = distance
		else
			opt_approach_mode = false
		end
 	end

	function instance:SetHighAccuracyDist(dist)
		opt_high_accuracy_dist = dist
	end

	function instance:SetTargetData(data)
		targetdata = data
 	end

	return instance
end

function brakesoff()
	if dullbotrecorderactive==true then
		local tempstring="+brakes 0"
		dullbotrecorderstepadvance(tempstring)
	end
	gkinterface.GKProcessCommand("+brakes 0")
end

function turnoffbrakes()
	local speed = 1
	speed = GetActiveShipSpeed() or 1
	speed = math.floor(speed)
	if speed == 0 then
		stoppingbraketimer:SetTimeout(1000,brakesoff)
	elseif speed > 0 then
		stoppingbraketimer:SetTimeout(300,turnoffbrakes)
	end
end


function brakingsequence()
	if stoppingbraketimer:IsActive() then
		stoppingbraketimer:Kill()
	end
	if dullbotapproachcargomode==true then
		local distance = GetTargetDistance()
		if distance ~= nil then
			if distance < 800 then
				if dullbotrecorderactive==true then
					local tempstring="Game.SetDesiredSpeed(0)"
					dullbotrecorderstepadvance(tempstring)
				end
				Game.SetDesiredSpeed(0)
				if dullbotrecorderactive==true then
					local tempstring="+brakes 1000"
					dullbotrecorderstepadvance(tempstring)
				end
				gkinterface.GKProcessCommand("+brakes 1000")
				if dullbotrecorderactive==true then
					local tempstring="it off"
					dullbotrecorderstepadvance(tempstring)
				end
				turboboolean=false
				gkinterface.GKProcessCommand("it off")
				stoppingbraketimer:SetTimeout(1000,turnoffbrakes)
			else
				if dullbotrecorderactive==true then
					local tempstring="Game.SetDesiredSpeed(100)"
					dullbotrecorderstepadvance(tempstring)
				end
				Game.SetDesiredSpeed(100)
				if dullbotrecorderactive==true then
					local tempstring="+brakes 1000"
					dullbotrecorderstepadvance(tempstring)
				end
				gkinterface.GKProcessCommand("+brakes 1000")
				if dullbotrecorderactive==true then
					local tempstring="it off"
					dullbotrecorderstepadvance(tempstring)
				end
				gkinterface.GKProcessCommand("it off")
				turboboolean=false
				stoppingbraketimer:SetTimeout(1000,turnoffbrakes)
			end
		else
			if dullbotrecorderactive==true then
				local tempstring="Game.SetDesiredSpeed(0)"
				dullbotrecorderstepadvance(tempstring)
			end
			Game.SetDesiredSpeed(0)
			if dullbotrecorderactive==true then
				local tempstring="+brakes 1000"
				dullbotrecorderstepadvance(tempstring)
			end
			gkinterface.GKProcessCommand("+brakes 1000")
			if dullbotrecorderactive==true then
				local tempstring="it off"
				dullbotrecorderstepadvance(tempstring)
			end
			gkinterface.GKProcessCommand("it off")
			turboboolean=false
			stoppingbraketimer:SetTimeout(1000,turnoffbrakes)
		end
	else
		if stopbetweenmoves==true then
			Game.SetDesiredSpeed(0)
			if dullbotrecorderactive==true then
				local tempstring="Game.SetDesiredSpeed(0)"
				dullbotrecorderstepadvance(tempstring)
			end
		else
			if dullbotrecorderactive==true then
				local tempstring="Game.SetDesiredSpeed(100)"
				dullbotrecorderstepadvance(tempstring)
			end
			Game.SetDesiredSpeed(100)
		end
		if dullbotrecorderactive==true then
			local tempstring="+brakes 1000"
			dullbotrecorderstepadvance(tempstring)
		end
		gkinterface.GKProcessCommand("+brakes 1000")
		if dullbotrecorderactive==true then
			local tempstring="it off"
			dullbotrecorderstepadvance(tempstring)
		end
		gkinterface.GKProcessCommand("it off")
		turboboolean=false
		stoppingbraketimer:SetTimeout(1000,turnoffbrakes)
	end
end



return dullbot
