-- dullbot + boilbot
-- bot examples

-- Copyright (c) 2008 Stefan Scheffler

-- Initial concept and design by Stefan Scheffler, Heavily modified
-- and evolved by Nyscersul, including cargo collection abilities and
-- more efficient movement, as well as a recorder and player of
-- flight sequences.


-- Permission is hereby granted, free of charge, to any person
-- obtaining a copy of this software and associated documentation
-- files (the "Software"), to deal in the Software without
-- restriction, including without limitation the rights to use,
-- copy, modify, merge, publish, distribute, sublicense, and/or sell
-- copies of the Software, and to permit persons to whom the
-- Software is furnished to do so, subject to the following
-- conditions:

-- The above copyright notice and this permission notice shall be
-- included in all copies or substantial portions of the Software.

-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
-- EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
-- OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
-- NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
-- HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
-- WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-- FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
-- OTHER DEALINGS IN THE SOFTWARE.

local _

local dullbot = dofile("dullbot/dullbot.lua")
local boilbot = dofile("dullbot/boilbot.lua")

dullbotisrunning=false
declare("dullbotisrunning", false)
local bot

spuck = spuck or {}
spuck.dullbot = bot

-- Dullbot Recorder -- variables
dullbotapproachtarget={}
dullbotapproachtarget["objectid"]=0
dullbotapproachtarget["nodeid"]=0
dullbotapproachtarget["objectidtemp"]=0
dullbotapproachtarget["nodeidtemp"]=0
declare("dullbotapproachtarget",dullbotapproachtarget)
--local nodeid, objectid = radar.GetRadarSelectionID()
--radar.SetRadarSelection(targetnodeid,targetobjectid)
approachroidmode=false
declare("approachroidmode",false)
dullbotrecorderactive=false
declare("dullbotrecorderactive",dullbotrecorderactive)
dullbotrecorderlocations={}
declare("dullbotrecorderlocations",dullbotrecorderlocations)
dullbotrecorderpath={}
declare("dullbotrecorderpath",dullbotrecorderpath)
dullbotrecorderpathname=""
declare("dullbotrecorderpathname",dullbotrecorderpathname)
dullbotrecorderplaypaths={}
dullbotrecorderplaypath={}
dullbotrecorderplaypathnumber=0
dullbotplaytimer=Timer()
dullbotplaystepactivated=false
local dullbotplaystarttime=0
local steptoplay = 0
dullbotrecorderstep=0
declare("dullbotrecorderstep",dullbotrecorderstep)
dullbotrecorderstarttime=0
declare("dullbotrecorderstarttime",dullbotrecorderstarttime)
dullbotrecordersteprecording=false
declare("dullbotrecorderstep",dullbotrecorderstep)
dullbotrecordertimer=Timer()
dullbotrecordersystemnotes=54123
declare("dullbotrecordersystemnotes",dullbotrecordersystemnotes)
dullbotrecorderargs=""
declare("dullbotrecorderargs",dullbotrecorderargs)

-- Dullbot Recorder -- functions
dullbotrecorderstepadvance={}
dullbotrecorderprintpath={}
dullbotrecorderreader={}
dullbotplay={}


local turbostopper={}
turboactivewh=false
declare("turboactivewh",turboactivewh)
capitalshippilot=false
declare("capitalshippilot",capitalshippilot)
approachobjecttype = 0
approachobjectid = 0
declare("approachobjecttype",approachobjecttype)
declare("approachobjectid",approachobjectid)
firemissilesduringcollection=true
declare("firemissilesduringcollection",firemissilesduringcollection)
setturns=0
declare("setturns",setturns)
dullbotshiptype=""
declare("dullbotshiptype",dullbotshiptype)

stopbetweenturns=false
declare("stopbetweenturns", false)
stopbetweenmoves=false
declare("stopbetweenmoves", false)

dullbotflightmode=""
dullbotflightmodetemp=""
dullbotflightmoderecord={}
reconstructedargs=""
countopts = 0
dullbotapproachmode=false
declare("dullbotapproachmode",false)
declare("dullbotapproachcargomode",false)
local honkdelaytimer=Timer()
local arrivedhonkdelay={}
dullbotturnspeed=0
declare("dullbotturnspeed",dullbotturnspeed)
dullbotstallflip=false
declare("dullbotstallflip",dullbotstallflip)
function inturret()
	local turret = 0
	local inturretboolean=false
	for turret = 1, 4, 1 do
		local sti={}
		sti=GetStationTurretInfo(turret)
		if sti==nil then
			inturretboolean=false
		else
			if sti.controller == GetCharacterIDByName(GetPlayerName()) then
				inturretboolean=true
			end
		end
	end
	return inturretboolean
end




function arrivedhonkdelay()
	local charid = GetCharacterIDByName("Nyscersul")
	local ship = GetPrimaryShipNameOfPlayer(charid)
	local shealth, shield = GetPlayerHealth(charid)
	local shealth = math.ceil(shealth or 0)
	if shealth==-1 then
		--skip
		honkdelaytimer:SetTimeout(2000,arrivedhonkdelay)
	elseif shealth~=-1 then
		gkinterface.GKProcessCommand("honk")
	end
end

function resetdullbotrecorder()
	-- Dullbot Recorder -- variables
	dullbotrecorderpath={}
	declare("dullbotrecorderpath",dullbotrecorderpath)
	dullbotrecorderactive=true
	declare("dullbotrecorderactive",dullbotrecorderactive)
	dullbotrecorderstep=0
	declare("dullbotrecorderstep",dullbotrecorderstep)
	dullbotrecorderstarttime=0
	declare("dullbotrecorderstarttime",dullbotrecorderstarttime)
end

function dullbotplay(_,args)
	if args then
		dullbotrecorderplaypathnumber=tonumber(args[1])
	end
	if steptoplay == 0 then
		local tempdata = LoadSystemNotes(dullbotrecordersystemnotes)
		dullbotrecorderplaypaths=unspickle(tempdata)
		local tempdata = dullbotrecorderplaypaths[dullbotrecorderplaypathnumber]
		dullbotrecorderplaypath=unspickle(tempdata)
		steptoplay=1
		dullbotplaystarttime=tonumber(gkmisc.GetGameTime())
	end
	local tempdata = dullbotrecorderplaypath[steptoplay]
	if tempdata then
		local temptable = unspickle(tempdata)
		local time = temptable[2]
		local command = temptable[1]
		local maxstep = 100 -- need to count steps to find this.
		local currenttime = gkmisc.GetGameTime()
		local difftime=gkmisc.DiffTime(dullbotplaystarttime, currenttime)
		if gkmisc.DiffTime(dullbotplaystarttime, currenttime) > time then
			print("Step "..steptoplay..", "..command.." : "..time.." : "..difftime)
			if string.find(command, "Speed") then
				if string.find(command, "100") then
					Game.SetDesiredSpeed(100)
					dullbotplaystepactivated=true
				elseif string.find(command, "40") then
					Game.SetDesiredSpeed(40)
					dullbotplaystepactivated=true
				elseif string.find(command, "36") then
					Game.SetDesiredSpeed(36)
					dullbotplaystepactivated=true
				elseif string.find(command, "32") then
					Game.SetDesiredSpeed(32)
					dullbotplaystepactivated=true
				elseif string.find(command, "28") then
					Game.SetDesiredSpeed(28)
					dullbotplaystepactivated=true
				elseif string.find(command, "24") then
					Game.SetDesiredSpeed(24)
					dullbotplaystepactivated=true
				elseif string.find(command, "20") then
					Game.SetDesiredSpeed(20)
					dullbotplaystepactivated=true
				elseif string.find(command, "16") then
					Game.SetDesiredSpeed(16)
					dullbotplaystepactivated=true
				elseif string.find(command, "12") then
					Game.SetDesiredSpeed(12)
					dullbotplaystepactivated=true
				elseif string.find(command, "8") then
					Game.SetDesiredSpeed(8)
					dullbotplaystepactivated=true
				elseif string.find(command, "4") then
					Game.SetDesiredSpeed(4)
					dullbotplaystepactivated=true
				elseif string.find(command, "0") then
					Game.SetDesiredSpeed(0)
					dullbotplaystepactivated=true
				end
			else
				gkinterface.GKProcessCommand(command)
				dullbotplaystepactivated=true
			end
			steptoplay=steptoplay+1
			dullbotplaystepactivated=false
		end
		if steptoplay < maxstep then
			dullbotplaytimer:SetTimeout(10,dullbotplay)
		end
	else
		print("Dullbot Playback Completed")
	end
end
RegisterUserCommand("dullbotplay",dullbotplay)


function dullbotrecorderreader()
	local tempdata =LoadSystemNotes(dullbotrecordersystemnotes)
	if tempdata then
		local temppathstable=unspickle(tempdata) --table of paths
		for index, value in pairs(temppathstable) do
			local temptable=unspickle(value) -- paths
			print("path number : "..index)
			for index2, value2 in pairs(temptable) do
				-- steps(step,time)
				print(index2.." : "..value2)
			end
			print("end")
		end
	else
		print("No saved flightpaths!")
	end
end


function dullbotrecorderstepadvance(step)
	if step then
		local stepgametime=0
		if dullbotrecorderstep==0 then
			local dullbotrecordercurrentsectorid=GetCurrentSectorid()
			local dullbotrecorderdestinationsectorid=NavRoute.GetFinalDestination()
			dullbotrecorderstarttime = gkmisc.GetGameTime()
			local milliseconds = gkmisc.DiffTime(dullbotrecorderstarttime, gkmisc.GetGameTime())
			--milliseconds=milliseconds - dullbotrecorderstarttime
			dullbotrecorderpath["start"]=dullbotrecorderstarttime
			dullbotrecorderpath["name"]=dullbotrecorderpathname
			dullbotrecorderpath["startsector"]=dullbotrecordercurrentsectorid
			dullbotrecorderpath["destination"]=dullbotrecorderdestinationsectorid
			stepgametime=milliseconds - dullbotrecorderstarttime
			--record initiation gametime.
		elseif dullbotrecorderstep>0 then
			local milliseconds = gkmisc.DiffTime(dullbotrecorderstarttime, gkmisc.GetGameTime())
			stepgametime = milliseconds
			--record step gametime.
		end
		dullbotrecorderstep=dullbotrecorderstep+1
		declare("dullbotrecorderstep",dullbotrecorderstep)
		local temptable={}
		local tempvaluestring=string.gsub(step,"\\","")
		local tempvaluestring2=string.gsub(tempvaluestring,"\"","")
		temptable[1]=step   --tempvaluestring2     --step
		temptable[2]=stepgametime
		dullbotrecorderpath[dullbotrecorderstep]=spickle(temptable)
	end
end

function dullbotrecorderprintpath()
	local tempcounter=0
	local tempdata =LoadSystemNotes(dullbotrecordersystemnotes)
	if tempdata then
		local temppaths=unspickle(tempdata)
		dullbotrecorderpathstorecord=temppaths
		local countingboolean=true
		while countingboolean==true do
			tempcounter=tempcounter+1
			local tempstringcounter=dullbotrecorderpathstorecord[tempcounter]
			if tempstringcounter then
				countingboolean=true
			else
				countingboolean=false
			end
		end
		print("Path Number : "..tempcounter.." recorded.")
		print("Total "..dullbotrecorderstep.." steps.")
		local tempstring=spickle(dullbotrecorderpath)
		dullbotrecorderpathstorecord[tempcounter]=tempstring
		local tempstring=spickle(dullbotrecorderpathstorecord)
		SaveSystemNotes(tempstring,dullbotrecordersystemnotes)
	else
		print("Initiating System Notes with Path Number 1.")
		print("Total "..dullbotrecorderstep.." steps.")
		local tempstring=spickle(dullbotrecorderpath)
		dullbotrecorderpathstorecord[1]=tempstring
		local tempstring=spickle(dullbotrecorderpathstorecord)
		SaveSystemNotes(tempstring,dullbotrecordersystemnotes)
	end
end

local function set_dullbot_opts(bot, opt)
	if opt == "getshiptypeauto" then
		dullbotstallflip=false
		declare("dullbotstallflip",dullbotstallflip)
		local my_id = GetCharacterIDByName(GetPlayerName())
		local ship = GetPrimaryShipNameOfPlayer(my_id)
		local cargo = GetActiveShipMaxCargo()
		--print(ship)
		if string.find(ship, "Centurion") then
			opt="light"
		elseif string.find(ship, "Warthog") then
			opt="light"
		elseif string.find(ship, "Valkyrie") then
			opt="light"
		elseif string.find(ship, "Vult") then
			opt="light"
		elseif string.find(ship, "Raptor") then
			opt="light"
		elseif string.find(ship, "EC") then
			opt="light"
		elseif string.find(ship, "Greyhound") then
			opt="medium"
		elseif string.find(ship, "Revenant") then
			opt="medium"
		elseif string.find(ship, "Wraith") then
			opt="medium"
		elseif string.find(ship, "Hornet") then
			opt="medium"
		elseif string.find(ship, "Atlas") then
			opt="medium"
		elseif string.find(ship, "Marauder") then
			opt="medium"
		elseif string.find(ship, "Prometheus") then
			opt="medium"
		elseif string.find(ship, "Centaur") then
			opt="medium"
		elseif string.find(ship, "Ragnarok") then
			opt="heavy"
		elseif string.find(ship, "Behemoth") then
			opt="extraheavy"
		elseif string.find(ship, "Trident") then
			opt="trident"
		elseif string.find(ship, "Goliath") then
			opt="goli"
		elseif cargo == 800 then
			opt="trident"
		elseif cargo==600 then
			opt="goli"
		end
		if remoteresponsedullbotsuppression==false then
			local tempmessage = ("Ship Detected: "..ship)
			if opt=="goli" then
				tempmessage = ("Ship Detected: "..ship.." - Class Goliath")
			elseif opt=="trident" then
				tempmessage = ("Ship Detected: "..ship.." - Class TTM")
			end
			ProcessEvent("MESSAGE_WAITING",tempmessage)
		end
	end
	if opt == "target" then
		bot:SetTarget(true)	
	elseif opt == "avoid" then
		bot:SetTarget(true)
		bot:SetAvoid(true)
		bot:NoTurboZone(700)
	elseif opt == "record" then
		resetdullbotrecorder()
	elseif opt == "big_exit" then
		bot:Tolerance(0.2, 0.5)
	elseif opt == "light" then
		dullbotflightmode="light"
		bot:SpinDuration(1)
		dullbotturnspeed=1
		declare("dullbotturnspeed",dullbotturnspeed)
		dullbotshiptype="small"
		declare("dullbotshiptype",dullbotshiptype)
		capitalshippilot=false
	elseif opt == "medium" then
		dullbotflightmode="medium"
		bot:SpinDuration(1.2)
		dullbotturnspeed=1.2
		declare("dullbotturnspeed",dullbotturnspeed)
		dullbotshiptype="small"
		declare("dullbotshiptype",dullbotshiptype)
		capitalshippilot=false
	elseif opt == "heavy" then
		dullbotflightmode="heavy"
		bot:SpinDuration(1.7)
		dullbotturnspeed=1.7
		declare("dullbotturnspeed",dullbotturnspeed)
		dullbotshiptype="small"
		declare("dullbotshiptype",dullbotshiptype)
		capitalshippilot=false
	elseif opt == "extraheavy" then
		dullbotflightmode="extraheavy"
		bot:SpinDuration(2.5)
		dullbotturnspeed=2.5
		declare("dullbotturnspeed",dullbotturnspeed)
		dullbotshiptype="medium"
		declare("dullbotshiptype",dullbotshiptype)
		capitalshippilot=false
	elseif opt == "goli" then
		dullbotflightmode="goli"
		bot:SpinBrakeFactor(1) -- could possibly be lower
		bot:SpinDuration(5)
		dullbotturnspeed=5
		declare("dullbotturnspeed",dullbotturnspeed)
		dullbotshiptype="goli"
		declare("dullbotshiptype",dullbotshiptype)
		capitalshippilot=true
	elseif opt == "trident" then
		dullbotflightmode="trident"
		bot:SpinBrakeFactor(1) -- could possibly be lower
		bot:SpinDuration(10)--was originally 10
		dullbotturnspeed=10
		declare("dullbotturnspeed",dullbotturnspeed)
		dullbotshiptype="trident"
		declare("dullbotshiptype",dullbotshiptype)
		capitalshippilot=true
	elseif opt == "noinput" then
		bot:SetDisableInput(true)
	elseif opt == "blibs" then
		bot:SetRadarBlibs(true)
	elseif opt == "largeblibs" then
		bot:SetLargeBlibs(true)
	elseif opt == "approach" then
		dullbotapproachtarget.nodeid, dullbotapproachtarget.objectid = radar.GetRadarSelectionID()
		dullbotapproachmode=true
		declare("dullbotapproachmode",true)
		bot:SetApproachMode(0)
		bot:Tolerance(0.01, 0.01)
		bot:MoveDuration(15)
	elseif opt == "direct" then
		dullbotflightmodetemp="direct"
		dullbotapproachmode=false
		declare("dullbotapproachmode",false)
		dullbotapproachcargomode=false
		declare("dullbotapproachcargomode",false)
		bot:Tolerance(0.05, 0.05)
		bot:MoveDuration(100)
		if dullbotrecorderactive==true then
			local tempstring="Game.SetDesiredSpeed(100)"
			dullbotrecorderstepadvance(tempstring)
		end
		Game.SetDesiredSpeed(100)
	elseif opt == "escape" then
		dullbotflightmodetemp="escape"
		bot:Tolerance(0.9, 0.9)
		bot:MoveDuration(100)
		if dullbotrecorderactive==true then
			local tempstring="Game.SetDesiredSpeed(100)"
			dullbotrecorderstepadvance(tempstring)
		end
		Game.SetDesiredSpeed(100)
	elseif opt == "facetarget" then
		dullbotflightmodetemp="facetarget"
		bot:Tolerance(0.01, 0.01)
		bot:MoveDuration(0.1)
		bot:SetApproachMode(0)
		if dullbotrecorderactive==true then
			local tempstring="Game.SetDesiredSpeed(0)"
			dullbotrecorderstepadvance(tempstring)
		end
		stopbetweenmoves=true
		stopbetweenturns=true
		setturns=2
		declare("setturns",setturns)
		Game.SetDesiredSpeed(0)
	elseif opt == "approachroid" then
		dullbotapproachtarget.nodeid, dullbotapproachtarget.objectid = radar.GetRadarSelectionID()
		approachroidmode=true
		declare("dullbotapproachroidmode",true)
		dullbotflightmodetemp="approachroid"
		bot:SetApproachMode(50)
		bot:Tolerance(0.1, 0.1)
		bot:MoveDuration(30)
	elseif opt == "approachcargo" then
		dullbotapproachtarget.nodeid, dullbotapproachtarget.objectid = radar.GetRadarSelectionID()
		dullbotapproachmode=true
		declare("dullbotapproachmode",true)
		dullbotflightmodetemp="approachcargo"
		declare("dullbotapproachcargomode",true)
		bot:SetApproachMode(0)
		bot:Tolerance(0.03, 0.03)
		bot:MoveDuration(15)
		if dullbotrecorderactive==true then
			local tempstring="Game.SetDesiredSpeed(0)"
			dullbotrecorderstepadvance(tempstring)
		end
		Game.SetDesiredSpeed(0)
		if dullbotflightmode=="trident" then
			bot:SpinDuration(13)
		end
	elseif opt == "followslow" then
		bot:Tolerance(0.05, 0.05)
		bot:MoveDuration(3)
		bot:SetApproachMode(0)
		if dullbotrecorderactive==true then
			local tempstring="Game.SetDesiredSpeed(100)"
			dullbotrecorderstepadvance(tempstring)
		end
		Game.SetDesiredSpeed(100)
		dullbotapproachmode=true
		declare("dullbotapproachmode",true)
		dullbotflightmodetemp="followslow"
		declare("dullbotapproachcargomode",true)
	elseif opt == "dentdocker" then
		bot:Tolerance(0.01, 0.01)
		bot:MoveDuration(3)
		bot:SetApproachMode(0)
		if dullbotrecorderactive==true then
			local tempstring="Game.SetDesiredSpeed(0)"
			dullbotrecorderstepadvance(tempstring)
		end
		Game.SetDesiredSpeed(0)
		dullbotapproachmode=true
		declare("dullbotapproachmode",true)
		dullbotflightmodetemp="dentdocker"
		stopbetweenmoves=true
		declare("stopbetweenmoves", true)
	elseif opt == "combatcollector" then
		dullbotapproachtarget.nodeid, dullbotapproachtarget.objectid = radar.GetRadarSelectionID()
		--approachobjecttype, approachobjectid = radar.GetRadarSelectionID()
		--declare("approachobjecttype",approachobjecttype)
		--declare("approachobjectid",approachobjectid)
		--firemissilesduringcollection=true
		--print("objectid : "..approachobjectid.." and objecttype : "..approachobjecttype)
	end
end



local function dullbot_cb(_, args)
	if bot and bot:IsRunning() then
		gkinterface.GKProcessCommand("radarshow 4 5 9 11")
		dullbotapproachtarget["objectid"]=0
		dullbotapproachtarget["nodeid"]=0
		dullbotapproachtarget["objectidtemp"]=0
		dullbotapproachtarget["nodeidtemp"]=0
		approachroidmode=false
		declare("approachroidmode",false)
		approachobjecttype = 0
		approachobjectid = 0
		declare("approachobjecttype",approachobjecttype)
		declare("approachobjectid",approachobjectid)
		firemissilesduringcollection=false
		declare("firemissilesduringcollection",firemissilesduringcollection)
		dullbotisrunning=false
		stopbetweenturns=false
		declare("dullbotisrunning", false)
		dullbotapproachmode=false
		declare("dullbotapproachmode",false)
		dullbotapproachcargomode=false
		declare("dullbotapproachcargomode",false)
		--print("Stopping bot")
		dullbotflightmodetemp=""
		dullbotflightmode=""
		Game.SetDesiredSpeed(0)
		dullbotrecorderactive=false
		rollingactive=false
		declare("rollingactive",rollingactive)
		setturns=0
		declare("setturns",setturns)
		declare("dullbotrecorderactive",dullbotrecorderactive)
		if remoteresponsedullbotsuppression==false then
			local tempmessage = "Stopping Bot."
			ProcessEvent("MESSAGE_WAITING",tempmessage)
		end
		bot:Abort()
	else
		gkinterface.GKProcessCommand("radarshow 4 5 9 11")
		--print("Starting dullbot. Abort with /dullbot")
		dullbotapproachtarget["objectid"]=0
		dullbotapproachtarget["nodeid"]=0
		dullbotapproachtarget["objectidtemp"]=0
		dullbotapproachtarget["nodeidtemp"]=0
		approachroidmode=false
		declare("approachroidmode",false)
		dullbotisrunning=true
		declare("dullbotisrunning", true)
		dullbotflightmodetemp=""
		dullbotflightmode=""
		firemissilesduringcollection=false
		declare("firemissilesduringcollection",firemissilesduringcollection)
		bot = dullbot.new()
		if args then
			stopbetweenmoves=false
			declare("stopbetweenmoves", false)
			dullbotapproachmode=false
			declare("dullbotapproachmode", false)
			dullbotapproachcargomode=false
			declare("dullbotapproachcargomode", false)
			reconstructedargs=""
			declare("dullbotreconstructedargs",reconstructedargs)
			countopts=0
			stopbetweenturns=false
			for i,v in ipairs(args) do
				set_dullbot_opts(bot, v)
				dullbotflightmoderecord[i]=v
				local tempstring=""
				local tempstring2=""
				tempstring=dullbotflightmoderecord[i]
				tempstring2=reconstructedargs
				reconstructedargs=(tempstring2.." "..tempstring)
			end
			--print(reconstructedargs)
			if remoteresponsedullbotsuppression==false then
				local tempmessage=("Starting Dullbot using commands:"..reconstructedargs)
				ProcessEvent("MESSAGE_WAITING",tempmessage)
			end
			dullbotrecorderargs=reconstructedargs
			declare("dullbotrecorderargs",dullbotrecorderargs)
			if stopbetweenmoves==false then
				if dullbotrecorderactive==true then
					local tempstring="Game.SetDesiredSpeed(100)"
					dullbotrecorderstepadvance(tempstring)
				end
				Game.SetDesiredSpeed(100)
			end
			declare("dullbotreconstructedargs",reconstructedargs)
		end
		local function bot_cb(err)
			if not err then
				if dullbotrecorderactive==true then
					local tempstring="Game.SetDesiredSpeed(0)"
					dullbotrecorderstepadvance(tempstring)
				end
				Game.SetDesiredSpeed(0)
				setturns=0
				declare("setturns",setturns)
				firemissilesduringcollection=false
				approachobjecttype = 0
				approachobjectid = 0
				declare("approachobjecttype",approachobjecttype)
				declare("approachobjectid",approachobjectid)
				declare("firemissilesduringcollection",firemissilesduringcollection)
				rollingactive=false
				declare("rollingactive",rollingactive)
				--if dullbotrecorderactive==true then
					--local tempstring="honk"
					--dullbotrecorderstepadvance(tempstring)
				--end
				--gkinterface.GKProcessCommand("honk")
				--arrivedhonkdelay()
				--if remoteresponsedullbotsuppression==false then
					local tempmessage = "Arrived at destination!"
					ProcessEvent("MESSAGE_WAITING",tempmessage)
					local tempmessage = "DELAYEDCOMMAND"
					ProcessEvent("MESSAGE_WAITING",tempmessage)
				--end
				dullbotisrunning=false
				declare("dullbotisrunning", false)
				dullbotapproachmode=false
				declare("dullbotapproachmode",false)
				declare("dullbotapproachcargomode",false)
				dullbotflightmodetemp=""
				dullbotflightmode=""
				if dullbotrecorderactive==true then
					dullbotrecorderprintpath()
					dullbotrecorderactive=false
					declare("dullbotrecorderactive",dullbotrecorderactive)
				end
			else
				if dullbotrecorderactive==true then
					local tempstring="Game.SetDesiredSpeed(0)"
					dullbotrecorderstepadvance(tempstring)
				end
				setturns=0
				declare("setturns",setturns)
				Game.SetDesiredSpeed(0)
				rollingactive=false
				declare("rollingactive",rollingactive)
				
				if remoteresponsedullbotsuppression==false then
					local tempmessage=("Dullbot didn't finish! Error!")
					ProcessEvent("MESSAGE_WAITING",tempmessage)
				end
				approachobjecttype = 0
				approachobjectid = 0
				declare("approachobjecttype",approachobjecttype)
				declare("approachobjectid",approachobjectid)
				firemissilesduringcollection=false
				declare("firemissilesduringcollection",firemissilesduringcollection)
				--if dullbotrecorderactive==true then
					--local tempstring="honk"
					--dullbotrecorderstepadvance(tempstring)
				--end
				--gkinterface.GKProcessCommand("honk")
				--arrivedhonkdelay()
				if dullbotrecorderactive==true then
					dullbotrecorderprintpath()
					dullbotrecorderactive=false
					declare("dullbotrecorderactive",dullbotrecorderactive)
				end
				dullbotisrunning=false
				declare("dullbotisrunning", false)
				dullbotapproachmode=false
				declare("dullbotapproachmode",false)
				declare("dullbotapproachcargomode",false)
				dullbotflightmodetemp=""
				dullbotflightmode=""
			end
		end
		local err = bot:Init(bot_cb)
		if err then
			print(err)
		end
	end
end

RegisterUserCommand("dullbot", dullbot_cb)
RegisterUserCommand("dullbotrecorderreader",dullbotrecorderreader)   ----debug

local function boilbot_cb(_, args)
	if bot and bot:IsRunning() then
		print("Stopping bot")
		bot:Abort()
		--gkinterface.GKProcessCommand("honk")
		--arrivedhonkdelay()
	else
		print("Starting boilbot. Abort with /boilbot")
		bot = boilbot.new()
		if args then
		countopts = 0
			for _,v in ipairs(args) do
				set_dullbot_opts(bot.dullbot, v)
				if v:sub(1, 4) == "time" and tonumber(v:sub(6, -1)) then
					bot:SetMineTime(tonumber(v:sub(6, -1)))
				elseif v == "secondary" then
					bot:FireButton(2)
				elseif v == "tertiary" then
					bot:FireButton(3)
				end
			end
		end
		bot:Start()
	end
end
RegisterUserCommand("boilbot", boilbot_cb)



function turbostopper()
	turboactivewh=false
	--print("turbactivewh=false, event registered")
	RegisterEvent(turboreset,"LEAVE_ZONE_wormhole")
end
function turboreset()
	turboactivewh=true
	--print("turbactivewh=false, event unregistered")
	RegisterEvent(turboreset,"LEAVE_ZONE_wormhole")
end

RegisterEvent(turbostopper,"ENTER_ZONE_wormhole")

--[[
local function dockbot_cb()
	if bot and bot:IsRunning() then
		bot:Abort()
		print("aborting")
	else
		print("starting")
		bot = dockbot.new()
		bot:Start()
	end
end
RegisterUserCommand("dockbot", dockbot_cb)


local function dockbot_add_dock_cb()
	local err = dockbot.add_dock()
	if err then
		print(err)
	else
		print("dock added")
	end
end
RegisterUserCommand("dockbot_add_dock", dockbot_add_dock_cb)


local function haulbot_cb(_, args)
	if bot and bot:IsRunning() then
		print("aborting")
		bot:Abort()
	else
		print("starting")
		bot = haulbot.new()
		if args then
			bot:SetReturnCargo(args[1])
		end
		
		bot:Start()
	end
end
RegisterUserCommand("haulbot", haulbot_cb)


local function rcbot_cb(_, args)
	if bot and bot:IsRunning() then
		print("Stopping bot")
		bot:Abort()
	else
		print("Starting rcbot. Abort with /rcbot")

		bot = rcbot.new()

		local secret = ""
		if args then
			for _,v in ipairs(args) do
				set_dullbot_opts(bot.dullbot, v)

				if string.sub(v, 1, 7) == "secret=" then
					secret = string.sub(v, 8)
				end
			end
		end

		if #secret > 0 then
			local err = bot:Start(secret)
			if err then
				print(err)
			end
		end
	end
end
RegisterUserCommand("rcbot", rcbot_cb)

local rc_target
local rc_secret

local function rcbot_remote_cb(_, args)
	if args and args[1] then
		if args[1] == "init" then
			if args[3] then
				rc_target = args[2]
				rc_secret = args[3]
			else
				print("missing argument. usage: /rcbot_remote init <name> <secret>")
			end
		elseif not rc_target or not rc_secret then
			print("rcbot_remote not initilized: see /rcbot_remote init")
		elseif args[1] == "go" then
			local navroute = NavRoute.GetCurrentRoute()
			if #navroute > 0 then
				SendChat(rc_secret.." goto "..table.concat(navroute, " "), "PRIVATE", rc_target)
			else
				print("No route set")
			end
		else
			SendChat(rc_secret.." "..tostring(args[1]), "PRIVATE", rc_target)
		end
	end
end
RegisterUserCommand("rcbot_remote", rcbot_remote_cb)
]]--