-- object finder

-- Copyright (c) 2008 Stefan Scheffler

-- Permission is hereby granted, free of charge, to any person
-- obtaining a copy of this software and associated documentation
-- files (the "Software"), to deal in the Software without
-- restriction, including without limitation the rights to use,
-- copy, modify, merge, publish, distribute, sublicense, and/or sell
-- copies of the Software, and to permit persons to whom the
-- Software is furnished to do so, subject to the following
-- conditions:

-- The above copyright notice and this permission notice shall be
-- included in all copies or substantial portions of the Software.

-- THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
-- EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
-- OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
-- NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
-- HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
-- WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
-- FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
-- OTHER DEALINGS IN THE SOFTWARE.
local turningleft = false
local turningvert = false
counterturnx={}  --- added by Nyscersul
counterturny={}
local amountx = 0
local amounty = 0
local counterturnxtimer=Timer() 
local counterturnytimer=Timer() --- added by Nyscersul
local counterturntimer=Timer()

local timetowaitforturn_stringv = ""
local timetowaitforturn_stringh = ""
local timetowaitforturn_v = 0
local timetowaitforturn_h = 0
local finder = {}

local finder = {}
local TCP = dofile("dullbot/tcpsock.lua")

-- these should be correct for all available ships
local TURN_DAMP = 4
local SPIN_SPEED = 1000

local MAX_RETRIES = 10

local function roboprint(str)
--	print("objectfinder: "..tostring(str))
end

finder.TYPE_PNG = 0
finder.TYPE_GL = 1

finder.FIND_SUCCESS = 1
finder.FIND_LOST = 2
finder.FIND_CONERROR = 3
finder.FIND_STUCK = 4

-- object types
finder.OT_DEFAULT = 0
finder.OT_GATE = 1
finder.OT_EXIT = 2
finder.OT_TARGET = 3
finder.OT_DOCK = 4
finder.OT_DOCKLIGHT1 = 5
finder.OT_DOCKLIGHT2 = 6
finder.OT_DOCKNOFOCUS = 7


cannontapsturn=1
cannonorderturn=1
cannontimerturn=Timer()
cannontapstime=1

local resetradartimer=Timer()


function inturret()
	local turret = 0
	local inturretboolean=false
	for turret = 1, 4, 1 do
		local sti={}
		sti=GetStationTurretInfo(turret)
		if sti ~= nil then
			if sti.controller == GetCharacterIDByName(GetPlayerName()) then
				inturretboolean=true
			end
		end
	end
	return inturretboolean
end

function firemissilesduringturn()
	print("debug missiles active")
	gkinterface.GKProcesscommand("cannontap1")
	print(cannontapstime)
	if cannontapstime >20 then
		cannontapsturn=8
	elseif cannontapstime > 17.5 then
		cannontapsturn=7
	elseif cannontapstime > 15 then
		cannontapsturn=6
	elseif cannontapstime > 12.5 then
		cannontapsturn=5
	elseif cannontapstime > 10 then
		cannontapsturn=4
	elseif cannontapstime > 7.5 then
		cannontapsturn=3
	elseif cannontapstime > 5 then
		cannontapsturn=2
	elseif cannontapstime > 2.5 then
		cannontapsturn=1
	elseif cannontapstime > 0 then
		cannontapsturn=0
	end
	print(cannontapsturn)
	cannontapcyclerturn()
end

function cannontapcyclerturn()
	if cannontapsturn > 0 then
		if cannonorderturn==1 then
			print("cannontap "..cannonorderturn)
			gkinterface.GKProcessCommand("cannontap1")
			cannonorderturn=2
		elseif cannonorderturn==2 then
			print("cannontap "..cannonorderturn)
			gkinterface.GKProcessCommand("cannontap2")
			cannonorderturn=3
		elseif cannonorderturn==3 then
			print("cannontap "..cannonorderturn)
			gkinterface.GKProcessCommand("cannontap3")
			cannonorderturn=4
		elseif cannonorderturn==4 then
			print("cannontap "..cannonorderturn)
			gkinterface.GKProcessCommand("cannontap4")
			cannonorderturn=1
		end
		cannontapsturn=cannontapsturn-1
		cannontimerturn:SetTimeout(2500,cannontapcyclerturn)
	end
end


local turrettimer=Timer()


function finder.new()
	if inturret() then
		turrettimer:SetTimeout(1,finder.new)
	else
	local instance = {}

	local stopped = false

	local IN_LEFT = 0
	local IN_RIGHT = 1
	local IN_UP = 2
	local IN_DOWN = 3
	local NUMKEYS = 4

	local opt_serverdir = ""
	local r_off_x = 0
	local r_off_y = 0
	local r_centerx = 0
	local r_centery = 0
	local r_size = 0

	local opt_blib_correction = 0

	local retries = 0

	local radarimage
	local radarcolor

	--local debugspot = iup.label{title="", image="", size="4x4"}
	--local debugbox = iup.cbox{debugspot, expand="YES", size="FULLxFULL"}
	--local debugdialog = iup.dialog{title="", fullscreen="YES", bgcolor="0 0 0 0", border="NO", debugbox}

	instance.spin_timer = Timer()
	instance.find_timer = Timer()

	local function get_radar()
		local iup=iup.GetBrother(iup.GetParent(HUD.leftradarlabel))
		if iup then
			return iup
		else
			return nil
		end
		--return iup.GetBrother(iup.GetParent(HUD.leftradarlabel))
	end

	local function setup_radar_info()
		local radar = get_radar()
		
		if radar~= nil and iup.GetType(radar) == "radar" then --modified
			r_off_x = tonumber(radar.X)
			r_off_y = tonumber(radar.Y)

			r_size = tonumber((radar.SIZE:gsub("x.*", "")))

			r_centerx = r_off_x + (r_size / 2)
			r_centery = r_off_y + (r_size / 2)
		else
			print("Warning! can't get radar info.")
		end
	end

	local function send_input_request(key, cb)
		local function conn_cb(conn, err)
			if err then
				print("Can't connect to input server. error: "..tostring(err))
				return
			end
			conn:Send("3 "..tostring(key).."\n")
		end

		local function line_cb(conn, line)
		end
		
		TCP.make_client("127.0.0.1", 44444, conn_cb, line_cb, cb or function() end)
	end

	
	local function spin_h(time)
		if dullbotrecorderactive==true then
			local tempstring="+brakes 0"
			dullbotrecorderstepadvance(tempstring)
		end
		gkinterface.GKProcessCommand("+brakes 0")
		turboactivewh=true
		roboprint("spin_h "..tostring(time))
		--print("spin_h "..tostring(time))
		if time then
			if Platform == "Windows" then
				local sign = (time > 0) and 1 or -1  
				if time == 10 then
					if turningleft==true then
						if turningvert==false then
							counterturn_manual()
							--print("debug counterturn initiated")
							--time = 0
						end
					end
				end
				local magnitude=(sign * SPIN_SPEED)
				local turntimeout=(math.abs(time))
				if dullbotrecorderactive==true then
					local tempstring="roll 0"
					dullbotrecorderstepadvance(tempstring)
				end
				gkinterface.GKProcessCommand("roll 0")
				--gkinterface.GKProcessCommand("turn "..(sign * SPIN_SPEED).. "; wait "..math.abs(time).." \"turn 0\"")
				--if time~=0 then
				timetowaitforturn_stringh=("turn "..magnitude.. "; wait "..turntimeout.." \"turn 0\"")
				--else
					--timetowaitforturn_stringh=("db180")
				---end
				gkinterface.GKProcessCommand(timetowaitforturn_stringh)  ---"turn "..(sign * SPIN_SPEED).. "; wait "..math.abs(time).." \"turn 0\""
				if dullbotrecorderactive==true then
					local tempstring=tostring(timetowaitforturn_stringh)
					dullbotrecorderstepadvance(tempstring)
				end
				--print(timetowaitforturn)
				timetowaitforturn_h=(time)
				--local timetowaitforturn_temp_h = timetowaitforturn_h
				--print(timetowaitforturn_h)
				--print("timetowaitforturn_h")
				--amounty = 1000
				--counterturnytimer:SetTimeout((timetowaitforturn_temp_h),(counterturny(amounty,timetowaitforturn_temp_h)))
				if stopbetweenturns==true then
					if dullbotrecorderactive==true then
						local tempstring="Game.SetDesiredSpeed(0)"
						dullbotrecorderstepadvance(tempstring)
					end
					Game.SetDesiredSpeed(0)
					if dullbotrecorderactive==true then
						local tempstring="+brakes 0"
						dullbotrecorderstepadvance(tempstring)
					end
					gkinterface.GKProcessCommand("+brakes 0")
				elseif dullbotapproachcargomode==true then
					if dullbotrecorderactive==true then
						local tempstring="+brakes 0"
						dullbotrecorderstepadvance(tempstring)
					end
					gkinterface.GKProcessCommand("+brakes 0")
					local distance = GetTargetDistance()
					if distance ~= nil then
						if dullbotshiptype=="small" then
							distance=distance*10
						elseif dullbotshiptype=="medium" then
							distance=distance*7
						elseif dullbotshiptype=="goli" then
							distance=distance*1.5
						elseif dullbotshiptype=="trident" then
							distance=distance
						end
						if distance > 5000 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(100)"
								dullbotrecorderstepadvance(tempstring)
							end
							Game.SetDesiredSpeed(100)
						elseif distance > 4500 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(100)"
								dullbotrecorderstepadvance(tempstring)
							end
							Game.SetDesiredSpeed(100)
						elseif distance > 4000 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(100)"
								dullbotrecorderstepadvance(tempstring)
							end
							Game.SetDesiredSpeed(100)
						elseif distance > 3500 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(100)"
								dullbotrecorderstepadvance(tempstring)
							end
							Game.SetDesiredSpeed(100)
						elseif distance > 3000 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(100)"
								dullbotrecorderstepadvance(tempstring)
							end
							Game.SetDesiredSpeed(100)
						elseif distance > 2500 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(100)"
								dullbotrecorderstepadvance(tempstring)
							end
							Game.SetDesiredSpeed(100)
						elseif distance > 2000 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(100)"
								dullbotrecorderstepadvance(tempstring)
							end
							Game.SetDesiredSpeed(100)
						elseif distance > 1500 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(100)"
								dullbotrecorderstepadvance(tempstring)
							end
							Game.SetDesiredSpeed(100)
						elseif distance > 1000 then
							--opt_move_duration = 10
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(100)"
								dullbotrecorderstepadvance(tempstring)
							end
							Game.SetDesiredSpeed(100)
						elseif distance > 750 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(75)"
								dullbotrecorderstepadvance(tempstring)
							end
							--opt_move_duration = 10
							Game.SetDesiredSpeed(75)
							--bot:MoveDuration(10)
							--bot:Tolerance(0.02, 0.02)
						elseif distance > 700 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(60)"
								dullbotrecorderstepadvance(tempstring)
							end
							--opt_move_duration = 8
							Game.SetDesiredSpeed(60)
							--bot:MoveDuration(10)
							--bot:Tolerance(0.02, 0.02)
						elseif distance > 650 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(40)"
								dullbotrecorderstepadvance(tempstring)
							end
							--opt_move_duration = 7
							Game.SetDesiredSpeed(40)
							--bot:MoveDuration(10)
							--bot:Tolerance(0.02, 0.02)
						elseif distance > 600 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(36)"
								dullbotrecorderstepadvance(tempstring)
							end
							--opt_move_duration = 6
							Game.SetDesiredSpeed(36)
							--bot:MoveDuration(10)
							--bot:Tolerance(0.02, 0.02)
						elseif distance > 550 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(32)"
								dullbotrecorderstepadvance(tempstring)
							end
							--opt_move_duration = 5
							Game.SetDesiredSpeed(32)
							--bot:MoveDuration(10)
							--bot:Tolerance(0.02, 0.02)
						elseif distance > 500 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(28)"
								dullbotrecorderstepadvance(tempstring)
							end
							--opt_move_duration = 5
							Game.SetDesiredSpeed(28)
							--bot:MoveDuration(10)
							--bot:Tolerance(0.02, 0.02)
						elseif distance > 450 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(24)"
								dullbotrecorderstepadvance(tempstring)
							end
							--opt_move_duration = 5
							Game.SetDesiredSpeed(24)
							--bot:MoveDuration(10)
							--bot:Tolerance(0.02, 0.02)
						elseif distance > 300 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(20)"
								dullbotrecorderstepadvance(tempstring)
							end
							--opt_move_duration = 5
							Game.SetDesiredSpeed(20)
							--bot:MoveDuration(10)
							--bot:Tolerance(0.02, 0.02)
						elseif distance > 250 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(16)"
								dullbotrecorderstepadvance(tempstring)
							end
							--opt_move_duration = 5
							Game.SetDesiredSpeed(16)
							--bot:MoveDuration(10)
							--bot:Tolerance(0.02, 0.02)
						elseif distance > 200 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(12)"
								dullbotrecorderstepadvance(tempstring)
							end
							--opt_move_duration = 5
							Game.SetDesiredSpeed(12)
							--bot:MoveDuration(10)
							--bot:Tolerance(0.02, 0.02)
						elseif distance > 150 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(8)"
								dullbotrecorderstepadvance(tempstring)
							end
							--opt_move_duration = 5
							Game.SetDesiredSpeed(8)
							--bot:MoveDuration(10)
							--bot:Tolerance(0.02, 0.02)
						elseif distance > 100 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(4)"
								dullbotrecorderstepadvance(tempstring)
							end
							--opt_move_duration = 5
							Game.SetDesiredSpeed(4)
							--bot:MoveDuration(10)
							--bot:Tolerance(0.02, 0.02)
						elseif distance > 50 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(1)"
								dullbotrecorderstepadvance(tempstring)
							end
							--opt_move_duration = 5
							Game.SetDesiredSpeed(1)
							--bot:MoveDuration(10)
							--bot:Tolerance(0.02, 0.02)
						elseif distance > 0 then
							if dullbotrecorderactive==true then
								local tempstring="Game.SetDesiredSpeed(0)"
								dullbotrecorderstepadvance(tempstring)
							end
							--opt_move_duration = 5
							Game.SetDesiredSpeed(0)
							--bot:MoveDuration(10)
							--bot:Tolerance(0.02, 0.02)
						end
					end
				else
					if dullbotrecorderactive==true then
						local tempstring="+brakes 0"
						dullbotrecorderstepadvance(tempstring)
					end
					gkinterface.GKProcessCommand("+brakes 0")
					if dullbotrecorderactive==true then
						local tempstring="Game.SetDesiredSpeed(100)"
						dullbotrecorderstepadvance(tempstring)
					end
					Game.SetDesiredSpeed(100)
				--debug
				end
			else
				local key
				if time > 0 then
					key = IN_LEFT
					send_input_request(IN_RIGHT + NUMKEYS)
					send_input_request(IN_LEFT)
				else
					key = IN_RIGHT
					send_input_request(IN_LEFT + NUMKEYS)
					send_input_request(IN_RIGHT)
				end
				local t = Timer()
				local function t_cb()
					send_input_request(key + NUMKEYS)
				end
				t:SetTimeout(math.abs(time * 1000), t_cb)
			end
		end
	end

	local function spin_v(time)
		if dullbotrecorderactive==true then
			local tempstring="+brakes 0"
			dullbotrecorderstepadvance(tempstring)
		end
		gkinterface.GKProcessCommand("+brakes 0")
		roboprint("spin_v "..tostring(time))
		--print("spin_v "..tostring(time))
		if time then
			if Platform == "Windows" then
				local sign = (time > 0) and 1 or -1  
				local magnitude=(sign * SPIN_SPEED)
				local pitchtimeout=(math.abs(time))
				if dullbotrecorderactive==true then
					local tempstring="roll 0"
					dullbotrecorderstepadvance(tempstring)
				end
				gkinterface.GKProcessCommand("roll 0")
				timetowaitforturn_stringv=("pitch "..magnitude.. "; wait "..pitchtimeout.." \"pitch 0\"")
				gkinterface.GKProcessCommand(timetowaitforturn_stringv)    ---"pitch "..(sign * SPIN_SPEED).. "; wait "..math.abs(time).." \"pitch 0\""
				if dullbotrecorderactive==true then
					local tempstring=tostring(timetowaitforturn_stringv)
					dullbotrecorderstepadvance(tempstring)
				end
				--print(timetowaitforturn)--debug
				timetowaitforturn_v=(time)
				--local timetowaitforturn_temp_v = timetowaitforturn_v
				--print(timetowaitforturn_v)
				--print("timetowaitforturn_v")
				--amountx = 1000
				--counterturnxtimer:SetTimeout((timetowaitforturn_temp_v),(counterturnx(amountx,timetowaitforturn_temp_v)))
				
				--debug
			else
				local key
				if time > 0 then
					key = IN_DOWN
					send_input_request(IN_UP + NUMKEYS)
					send_input_request(IN_DOWN)
				else
					key = IN_UP
					send_input_request(IN_DOWN + NUMKEYS)			
					send_input_request(IN_UP)
				end

				local t = Timer()
				local function t_cb()
					send_input_request(key + NUMKEYS)
				end
				t:SetTimeout(math.abs(time * 1000), t_cb)
			end
		end
	end

	local function target(t)
		radar.SetRadarSelection(2, tonumber(t))
	end


	-- reply handlers for each object type
	local replyhandler = {}
	
	local dockx
	local docky
	local dockdist
	local lightx
	local lighty
	local lightdist

	replyhandler[finder.OT_DEFAULT] = function(object_type, data, tolerance, spin_duration, brake_factor, cb, x, y)
		-- spin ship based on values returned from server
		-- or call cb when centered on gate or exit point
		
		-- AFAIK there's no way to tell if I'm rotating or not
		-- so the bot estimates the time till stop based on torque/damping ratio
		local brake_time = spin_duration * brake_factor
		
		local norm_x = 1
		local norm_y = 0
		
		if x and x >= 0 and y and y >= 0 then
			norm_x = (r_centerx - x) / (r_size / 2)
			norm_y = (r_centery - y) / (r_size / 2)
		end
			
		if math.abs(norm_x) <= tolerance and 
			math.abs(norm_y) <= tolerance
		then
			-- docks need special treatment
			if object_type == finder.OT_DOCK then
				dockx = x
				docky = y
				dockdist = GetTargetDistance()

				target(data.light1)
				
				instance:find(finder.OT_DOCKLIGHT1, data, tolerance, spin_duration, brake_factor, cb)
			else
				retries = 0
				cb(finder.SUCCESS)
			end
		else
			instance.spin_timer = Timer()
			
			local scaled_x = spin_duration * (math.asin(norm_x) / (math.pi / 2))
			if math.abs(norm_x) > tolerance then
				--print(scaled_x)
				--print("scaled_x")
				if scaled_x == 10 then
					turningleft=true
				else
					turningleft=false
				end
				spin_h(scaled_x)
			end
			
			local scaled_y = spin_duration * (math.asin(norm_y) / (math.pi / 2))
			if math.abs(norm_y) > tolerance then
				if scaled_y > 0 then
					turningvert=true
				elseif scaled_y < 0 then
					turningvert=true
				else
					turningvert=false
				end
				spin_v(scaled_y)
			end
			
			roboprint("spin: "..scaled_x.." "..scaled_y.." "..norm_x.." "..norm_y)
			--print("spin: "..scaled_x.." "..scaled_y.." "..norm_x.." "..norm_y)
			
			local function spin_cb()
				local turrettimer2=Timer()
				if inturret() then
					turrettimer2:SetTimeout(1,spin_cb)
				else
					instance:find(object_type, data, tolerance, spin_duration, brake_factor, cb)
				end
			end
			--local debugmessage = retries --(spin_duration + brake_time) * 1000
			--print(debugmessage)
			--print("(spin_duration + brake_time) * 1000")
			--print("timetowaitforturn_h : "..tostring(timetowaitforturn_h))
			--print()
			--print("timetowaitforturn_v : "..tostring(timetowaitforturn_v))
			--print()
			local timetowaitforturn_s = 0

			if timetowaitforturn_v < 0 then
				timetowaitforturn_v = timetowaitforturn_v * -1
			end

			if timetowaitforturn_h < 0 then
				timetowaitforturn_h = timetowaitforturn_h * -1
			end
			if timetowaitforturn_v > timetowaitforturn_h then
				timetowaitforturn_s = timetowaitforturn_v
			elseif timetowaitforturn_h > timetowaitforturn_v then
				timetowaitforturn_s = timetowaitforturn_h
			elseif timetowaitforturn_v == timetowaitforturn_h then
				timetowaitforturn_s = timetowaitforturn_v
			end
			
			local braking_time_mod = 0
			if capitalshippilot==false then
				braking_time_mod=brake_time
			elseif dullbotflightmode=="goli" then
				if (timetowaitforturn_s * 2.5) > 13 then
					braking_time_mod = 13
				elseif (timetowaitforturn_s * 2.5) <= 13 then
					braking_time_mod = (timetowaitforturn_s * 2.5)
				end
			else
				if (timetowaitforturn_s * 4) > 20 then
					braking_time_mod = 20
				elseif (timetowaitforturn_s * 4) <= 20 then
					braking_time_mod = (timetowaitforturn_s * 4)
				end
			end
			--print("braking_time_mod : "..tostring(braking_time_mod))
			--print()
			if capitalshippilot==false then
				if braking_time_mod < 0.5 then
					braking_time_mod = 0.5
				end
			elseif dullbotflightmode=="trident" then
				if braking_time_mod < 5 then
					braking_time_mod = 5
				end
			elseif dullbotflightmode=="goli" then
				if braking_time_mod < 4 then
					braking_time_mod=4
				end
			end
			if turningleft==true then
				if turningvert==false then
					braking_time_mod=23
					--braking_time_mod=3*spin_duration
				end
			end
			turningleft=false
			turningvert=false
			
			
			--print("braking_time_mod : "..tostring(braking_time_mod))
			--print("braking_time_mod")
			--instance.spin_timer:SetTimeout((spin_duration + brake_time) * 1000, spin_cb)
			instance.spin_timer:SetTimeout((braking_time_mod * 1000), spin_cb)
			--print("instance.spin_timer:SetTimeout((braking_time_mod * 1000), spin_cb)")
			timetowaitforturn_stringv=""
			timetowaitforturn_stringh=""
			timetowaitforturn_v = 0
			timetowaitforturn_h = 0
			if firemissilesduringcollection==true then
				--gkinterface.GKProcessCommand("cannontap1")
				--cannontapstime=3 --debug
				--print("fire missiles debug")
				--firemissilesduringturn()
				cannontapstime=tonumber(braking_time_mod)
				cannontapcyclerturn()
			end
		end
	end

	-- TODO: if dock is out of sight turn towards midpoint between lights
	-- or better yet try to get away from the dock ..somehow
	replyhandler[finder.OT_DOCKNOFOCUS] = function(object_type, data, tolerance, spin_duration, brake_factor, cb, x, y)
		dockx = x
		docky = y
		dockdist = GetTargetDistance()

		target(data.light1)

		instance:find(finder.OT_DOCKLIGHT1, data, tolerance, spin_duration, brake_factor, cb)
	end
	
	replyhandler[finder.OT_DOCKLIGHT1] = function(object_type, data, tolerance, spin_duration, brake_factor, cb, x, y)

		if not tonumber(x) or x == -1 or not tonumber(y) or y == -1 then

			target(data.dock)
				
			retries = 0
			cb(finder.FIND_LOST)
			return
		end

		lightx = x
		lighty = y
		lightdist = GetTargetDistance()

		target(data.light2)

		instance:find(finder.OT_DOCKLIGHT2, data, tolerance, spin_duration, brake_factor, cb)
	end
	

	replyhandler[finder.OT_DOCKLIGHT2] = function(object_type, data, tolerance, spin_duration, brake_factor, cb, x, y)
		if not tonumber(x) or x == -1 or not tonumber(y) or y == -1 then
			target(data.dock)

			retries = 0
			cb(finder.FIND_LOST)
			return
		end

		-- add angle between one of the lights and the docking bay to the opposing light
		-- this puts the target right between the lights if the bot is lined up
		-- slightly ahead of the bay if not
		local function absolute_midpoint_with_bias(x1, y1, x2, y2)
			
			local function relative_midpoint_with_bias(a, b, r_center, dock)
				local r_radius = (r_size / 2)
				
				-- relative pos in radiants
				local ar = math.asin((a - r_center) / r_radius)
				local br = math.asin((b - r_center) / r_radius)
				local dockr = math.asin((dock - r_center) / r_radius)
						
				-- difference between docking bay and biased light midpoint
				local diff = br - dockr
				
				-- second level bias if behind docking bay
				local invdiff2 = 0
				if (lightdist - 15) > dockdist and (GetTargetDistance() - 15) > dockdist then
					
					local diff2 = ((ar + br) / 2) - dockr
					-- invert difference
					-- the smaller angle the stronger the bias
					-- XXX this is dumb

					if diff2 < 0 then
						invdiff2 = (math.pi / -2) - diff2
					else
						invdiff2 = (math.pi / 2) - diff2
					end
					roboprint(string.format("DIFF2: diff2 %f", diff2))
				end
				roboprint(string.format("MIDPOINT: r_center %i r_radius %i a %i b %i ar %f br %f diff %f midr %f invdiff2 %f midr2 %f", r_center, r_radius, a, b, ar, br, diff, ar + diff, invdiff2, ar + diff + invdiff2 ))

				return ar, diff + invdiff2
			end
			
			local basex, midrelx = relative_midpoint_with_bias(x1, x2, r_centerx, dockx)
			local basey, midrely = relative_midpoint_with_bias(y1, y2, r_centery, docky)

			local length = math.sqrt(midrelx*midrelx + midrely*midrely)
			roboprint(string.format("scalefactor %f", length))

			local MAXLEN = 0.5
			if length > MAXLEN then
				local scalefactor = math.sqrt((MAXLEN ^ 2) / ((midrelx ^ 2) + (midrely ^ 2)))
				midrelx = midrelx * scalefactor
				midrely = midrely * scalefactor
			end
			midrelx = basex + midrelx
			midrely = basey + midrely

			local function reltoabs(r_center, rel)
				return r_center + (math.sin(rel) *  (r_size / 2))
			end
			
			return reltoabs(r_centerx, midrelx), reltoabs(r_centery, midrely)
		end
		
		local midx,midy = absolute_midpoint_with_bias(lightx, lighty, x, y)
		
		

		roboprint(string.format("LIGHTS: x1 %i y1 %i - x2 %i y2 %i midx %i midy %i", lightx, lighty, x, y, midx, midy))

		-- turn to midx/y
		-- XXX: this crap is mostly copied from OT_DEFAULT they should share it
		local brake_time = spin_duration * brake_factor
		
		local norm_x = (r_centerx - midx) / (r_size / 2)
		local norm_y = (r_centery - midy) / (r_size / 2)
		
		if math.abs(norm_x) <= tolerance and 
			math.abs(norm_y) <= tolerance 
		then
			target(data.dock)
			retries = 0
			cb(finder.FIND_SUCCESS)
		else
			roboprint("turning to midpoint")

			instance.spin_timer = Timer()
			
			local scaled_x = spin_duration * (math.asin(norm_x) / (math.pi / 2))
			if math.abs(norm_x) > tolerance then
				if scaled_x == 10 then
					--print("turning left")
					spin_h(scaled_x)
				end
			end
			
			local scaled_y = spin_duration * (math.asin(norm_y) / (math.pi / 2))
			if math.abs(norm_y) > tolerance then
				spin_v(scaled_y)
			end
			
			roboprint("spin: "..scaled_x.." "..scaled_y.." "..norm_x.." "..norm_y)
			
			local function spin_cb()
				target(data.dock)

				instance:find(finder.OT_DOCKNOFOCUS, data, tolerance, spin_duration, brake_factor, cb)
			end
			instance.spin_timer:SetTimeout((spin_duration + brake_time) * 1000, spin_cb)
		end
	end
	
	-- common stuff for both finders
	-- does all the networking stuff
	-- calls one of the object type handlers above with the server reply
	function instance:find_common(object_type, data, tolerance, spin_duration, brake_factor, cb)
		roboprint("find common")
		
		stopped = false
		local maxretry=0
		if setturns>0 then
			maxretry=setturns
		else
			maxretry=MAX_RETRIES
		end
		if retries > maxretry then
			if retries < MAX_RETRIES then
				gkinterface.GKProcessCommand("dullbot")
			elseif retries > maxretry then
				local fliptimer=Timer()
				local fliptimer2=Timer()
				local fliptimer3=Timer()
				dullbotstallflip=true
				declare("dullbotstallflip",dullbotstallflip)
				local function tempdullbotreset()
					if dullbotisrunning==true then
						gkinterface.GKProcessCommand("dullbot")
					end
				end
				fliptimer:SetTimeout(250, tempdullbotreset)
				local timeout = (((dullbotturnspeed * 3)*1000)+1000)
				fliptimer2:SetTimeout(timeout, function() gkinterface.GKProcessCommand("dullbot "..dullbotreconstructedargs) end)
				retries=0
				fliptimer3:SetTimeout(500, function() gkinterface.GKProcessCommand("db180") end)
				return
			end
			--retries = 0
			--cb(finder.FIND_STUCK)
			--return
		end
		if dullbotapproachmode==false then
			retries = retries + 1
		end
		
		-- TODO: use event, wait for image saved message
		local got_line

		local function conn_cb(conn, err)
			if err then
				print("Can't connect to dullbot server. error: "..tostring(err))
				retries = 0
				if cb then cb(finder.FIND_CONERROR) end
				return
			end
			conn:Send("2 "..
				  tostring(r_off_x).." "..
				  tostring(r_off_y).." "..
				  tostring(r_size-1).." "..
				  tostring(r_size-1).." "..
				  tostring(object_type).."\n")
		end

		local function line_cb(conn, line)
			got_line = true

			if stopped then return end

			local _, _, x, y = line:find("([^ ]-) ([^ ]-)$")
			
			x = tonumber(x)
			y = tonumber(y)
			if not x or not y then
				print("Bad reply from dullbot server")
				retries = 0
				conn.tcp:Disconnect()
				if cb then cb(finder.FIND_CONERROR) end
				return
			end

			if x < 0 then x = nil end
			
			if y < 0 then
				y = nil
			else
				y = y + 8-- debug was     y + opt_blib_correction
			end

			if replyhandler[object_type] then
				replyhandler[object_type](object_type, data, tolerance, spin_duration, brake_factor, cb, x, y)
			else
				replyhandler[finder.OT_DEFAULT](object_type, data, tolerance, spin_duration, brake_factor, cb, x, y)
			end

			--if x and y then
			--	debugspot.CX = x
			--	debugspot.CY = y
			--	debugbox:map()
			--	iup.Refresh(debugbox)
			--end
		end
		
		local function disc_cb()
			if stopped then return end
		
			if not got_line then
				print("Dullbot server disconnected without reply")
				retries = 0
				if cb then cb(finder.FIND_CONERROR) end
				return
			end
		end

		TCP.make_client("127.0.0.1", 44444, conn_cb, line_cb, disc_cb)
	end
	

	local function radar_blank()
		gkinterface.GKProcessCommand("radarhide 4 5 9 11")   -- radardebug
		local radar = get_radar()
		radar.bgcolor = "0 0 0 255 *"
		radar.IMAGE = ""
	end
	
	local function radar_restore()
		local radar = get_radar()
		radar.bgcolor = radarcolor
		radar.IMAGE = radarimage
	end
	

	local function get_servertype(cb)
		local reply
		local got_line
		
		local function conn_cb(conn, err)
			if err then
				print("Can't connect to dullbot server. error: "..tostring(err))
				retries = 0
				if cb then cb(nil, "failed to connect to dulbot server") end
				return
			end
			conn:Send("1\n")
		end
		
		local function disc_cb()
			if not got_line then
				print("Dullbot server disconnected without reply")
				retries = 0
				if cb then cb(nil, "dullbot server disconnected without reply") end
			end
		end
		
		local function line_cb(conn, line)
			got_line = true
			conn.tcp:Disconnect()
			if cb then cb(tonumber(line:sub(1,1))) end
		end
		
		TCP.make_client("127.0.0.1", 44444, conn_cb, line_cb, disc_cb)

	end

	function instance:find_png(object_type, data, tolerance, spin_duration, brake_factor, cb)
		--- added new below this line
		--print("find_png called")
		--local nodeidtemp,objectidtemp=radar.GetRadarSelectionID()
		if dullbotapproachtarget.objectid ~= 0 then -- and dullbotapproachtarget.objectid~=oobjectidtemp then
			--if GetTargetInfo() then
				--dullbotapproachtarget.nodeidtemp=nodeidtemp
				--dullbotapproachtarget.objectidtemp=objectidtemp
			--else
				--dullbotapproachtarget.nodeidtemp=0
				--dullbotapproachtarget.objectidtemp=0
			--end
			radar.SetRadarSelection(dullbotapproachtarget.nodeid,dullbotapproachtarget.objectid)
		--else
			--dullbotapproachtarget.nodeidtemp=0
			--dullbotapproachtarget.objectidtemp=0
		end
		--if dullbotapproachtarget.nodeidtemp~=0  then
			--resetradartimer:SetTimeout(1500,function() radar.SetRadarSelection(dullbotapproachtarget.nodeidtemp,dullbotapproachtarget.objectidtemp) end)
		--end
		------
		
		radar_blank()
		local function timer_cb()
			local function timer_cb()
				radar_restore()
				self:find_common(object_type, data, tolerance, spin_duration, brake_factor, cb)
			end
			self.find_timer:SetTimeout(1000, timer_cb)
			gkinterface.GKProcessCommand("dump "..opt_serverdir.."/dump.png")
			gkinterface.GKProcessCommand("radarshow 4 5 9 11") -- radardebug
		end
		self.find_timer:SetTimeout(500, timer_cb)
	end
	
	function instance:find_gl(object_type, data, tolerance, spin_duration, brake_factor, cb)
		radar_blank()
		self:find_common(object_type, data, tolerance, spin_duration, brake_factor, cb)
		radar_restore()
	end

	function instance:find(object_type, data, tolerance, spin_duration, brake_factor, cb)
		local function servertype_cb(type, err)
			if type == finder.TYPE_GL then
				roboprint("using gl server")
				--print("using gl server")
				self:find_gl(object_type, data, tolerance, spin_duration, brake_factor, cb)
			elseif type == finder.TYPE_PNG then
				roboprint("using png server")
				--print("using png server")
				self:find_png(object_type, data, tolerance, spin_duration, brake_factor, cb)
			else
				print("CONERROR")
				if cb then cb(finder.FIND_CONERROR) end
			end
		end
		get_servertype(servertype_cb)
	end

	function instance:Init(sdir)
		roboprint("init")

		local radar = get_radar()
		radarimage = radar.IMAGE
		radarcolor = radar.bgcolor

		opt_serverdir = sdir
		setup_radar_info()

		retries = 0
		
		--debugdialog:show()
	end

	function instance:Stop()
		stopped = true
		
		radar_restore()

		retries = 0

		self.find_timer:Kill()
		self.spin_timer:Kill()
		--debugdialog:destroy()
	end

	function instance:SetBlibCorrection(correction)
		opt_blib_correction = correction
	end
	return instance
	end --turretcheck
end
counterturn_manual={}
function counterturn_manual()
	--print("Counterturn Initiated")
	if dullbotrecorderactive==true then
		local tempstring="Game.SetDesiredSpeed(0)"
		dullbotrecorderstepadvance(tempstring)
	end
	if approachroidmode~=true then
		Game.SetDesiredSpeed(0)
	end
	if dullbotrecorderactive==true then
		local tempstring="pitch 0; wait 17 turn -1000; wait 6.0 turn 0"
		dullbotrecorderstepadvance(tempstring)
	end
	gkinterface.GKProcessCommand("pitch 0; wait 17 turn -1000; wait 6.0 turn 0")
	if approachroidmode~=true then
		counterturntimer:SetTimeout(3000,counterturnspeed)
	end
end
function counterturnspeed()
	--print("debug - speed dropped")
	if dullbotrecorderactive==true then
		local tempstring="Game.SetDesiredSpeed(0)"
		dullbotrecorderstepadvance(tempstring)
	end
	Game.SetDesiredSpeed(0)
end
function counterturnx(amountx,timetowaitforturn_v)
	local timetowaitforturn_temp_v=timetowaitforturn_v/3
	gkinterface.GKProcessCommand("pitch "..(amountx).. "; wait "..(timetowaitforturn_temp_v).." \"pitch 0\"")
--print("Counterturn X Initiated")
end
function counterturny(amounty,timetowaitforturn_h)
	local timetowaitforturn_temp_h=timetowaitforturn_h/3
	gkinterface.GKProcessCommand("turn "..(amountx).. "; wait "..(timetowaitforturn_temp_h).." \"turn 0\"")
--print("Counterturn X Initiated")
end


return finder