-- TurretHop 1.4 by AbortRetryFail

local targetcache = {}
local psm = function(msg) HUD.PrintSecondaryMsg(HUD,msg) end

local function GetTurret(turret)
	local turretnames = GetTurretNamesByStationType(GetStationType())
	local sti = GetStationTurretInfo(turret)
	if not sti then return end -- bail out!
	psm("Switching to turret "..tostring(turret)..": "..tostring(turretnames[sti.itemid]).." ("..InvManager.GetInventoryItemParameter(sti.itemtype, "Name")..")")
	PurchaseMerchandiseItem(sti.itemid)
	radar.SetRadarSelection(unpack(targetcache))
end

local function HUD_SHOW(event, data)
	if data and data == "turret" then
		radar.SetRadarSelection(unpack(targetcache))
	end
end
RegisterEvent(HUD_SHOW, "HUD_SHOW")


local deferred = function() return end
local function HUD_HIDE(event, data)
	deferred()
end
RegisterEvent(HUD_HIDE, "HUD_HIDE")


function TurretHop(_, args)
	targetcache = {radar.GetRadarSelectionID()} 
	local numturrets = GetNumStationTurrets()
	local turret = tonumber(args[1])
	if numturrets and turret and turret >= 1 and turret <= numturrets then
		if HUD.hudtype == "turret" then
			gkinterface.GKProcessCommand("Activate")
			if GetActiveShipSpeed() >= GetActiveShipMaxSpeed() then
				-- Try not to un-turbo while switching turrets
				deferred = function()
					GetTurret(turret)
					deferred = function() return end
				end
			else
				GetTurret(turret)
			end
		else	
			GetTurret(turret)
		end
	end
end

RegisterUserCommand("turrethop", TurretHop)
